package analysis;

import symantec.itools.awt.WrappingLabel;
import symantec.itools.awt.util.ProgressBar;
import java.awt.*;
import RVLS.*;
import VisualNumerics.math.Statistics;

public class anovaAv extends oneSampleAv {
	double [][] xx;
	String dv;


	public  void setData(double [][] xx, String dv) {
		this.xx=xx;
		this.dv=dv;

	}
	public double simulate(int iter) {

		int k = xx.length;
		int TN=0;
		double [] means = new double[k];
		for (int i=0;i<k;i++) {
			means[i]=0;
			for (int j=0;j<xx[i].length;j++) {
				means[i]+=xx[i][j];
				TN++;
			}
			means[i]/=xx[i].length;
			for (int j=0;j<xx[i].length;j++) {
				xx[i][j] -= means[i];
			}
		}
		//double fcrit=2.68;
		//double fcrit = probFandT.Finv(sigLevel,k-1,TN-k);
                double fcrit = Statistics.inverseFCdf(1.0-sigLevel,(double)(k-1),(double)(TN-k));

		//for (int i=0;i<k;i++) {
			//System.out.println("mean " + i + " " + means[i]);
		//}

		double [][] X = new double[k][];
		for (int i=0;i<k;i++) {
			X[i]=new double[xx[i].length];
		}
		double p=0;
		int nsig=0;
//iter=2;
		anova an = new anova();
		for (int i=0;i<iter;i++) {
			for (int j=0;j<k;j++) {
				int N = X[j].length;
				for (int jj=0;jj<N;jj++) {
					X[j][jj] = xx[j][(int) Math.floor(Math.random()*N)];
				}
			}
		//System.out.println("Z");
			an.setData(X);
			if (an.getF() >= fcrit) nsig++;
			if (i%100 == 0) {
				double pr = ((double) i)/((double) iter);
				int pr0 = (int) Math.rint(100*pr);
				try {
					progressBar1.setValue(pr0);
				}
				catch(Exception e) { }

		}
		}
		p= (double) nsig/ (double) iter;
		return p;
		}


}
