package analysis;

import symantec.itools.awt.util.ProgressBar;
import java.awt.*;
import java.applet.*;
import java.net.*;
import java.net.URL;
import java.net.URLConnection;
import java.net.MalformedURLException;
import java.io.*;
import java.util.*;
import RVLS.*;



public class dataReader extends Panel implements Runnable {
	URL theURL;
	Thread gd;
	genApp r;
	String url;
	Label label1;
	//ProgressBar progressBar1;
	Dimension d;

	public dataReader() {
		setLayout(null);
		setSize(200,60);
		label1 = new java.awt.Label("");
		label1.setBounds(0,0,200,60);
		this.add(label1);
		label1.setText("Preparing to read data");


	}

	public void getData(String dsn) {

		//url="http://www.ruf.rice.edu/~lane/stat_analysis/testing/" + dsn;
		//url="file:///StarMax%20HD/Visual%20Cafe%202.0%20PDE/RVLS%20/analysis/" + dsn;
		label1.setText("Preparing to read data");
		url=dsn;
		//start();
		gd = new Thread(this);
		gd.start();
	}

	/*

	public void start () {
				message m = new message("thread starting");
				m.show();
		}

		*/

		public void stop () {

			if (gd != null) {

				gd.stop();
				gd=null;
			}
		}
	public void run() {

			Vector D = new Vector(50);
			Vector varNames = new Vector(5);
			boolean OK=true;

		try {
			int x=0;
			theURL = new URL(url);
			label1.setText("Making connection");
		}
		catch (Exception e) {
				//System.out.println("Bad url: " + theURL);
				label1.setText("Bad url: " + theURL);
				message m = new message("Bad url: " + theURL);
				m.show();
				OK=false;
				stop();

		}

		URLConnection conn=null;
		DataInputStream data=null;
		String line;
		StringTokenizer st;
		int k;

		try {
			conn=theURL.openConnection();
			conn.connect();
			label1.setText("Connection made");
			String all="";
			data = new DataInputStream( new BufferedInputStream(conn.getInputStream()));
			line = data.readLine();

			st = new StringTokenizer(line);
			k = st.countTokens();
			String [] vNames = new String[k];
			for (int i=0;i<k;i++) {
				String vn = st.nextToken();
				varNames.addElement(vn);
				vNames[i]= vn;
			}
			int N=0;

			double [] X = new double [k];

			double [] A;
			label1.setText("Reading data");

			try {
				for (int i=0;i<k;i++) {
					String vnt = vNames[i];
					X[i] = Double.valueOf(vnt).doubleValue();
				}

				varNames.removeAllElements();
				for (int i=0;i<k;i++) {
					varNames.addElement("var" + (i+1));
				}
				D.addElement(X.clone());

			}
			catch (Exception e){
				//first line contains labels
			}






			while (true) {
				line = data.readLine();

				if(line == null) {
					break;
				}


				if (line.length() != 0) {
					N++;
					if (N%10 == 0)
						label1.setText("Reading line " + N);

					 st = new StringTokenizer(line);

					int nt = st.countTokens();
					if (nt != k) {

						message m = new message("Wrong number of items!");
						m.show();
						OK=false;
						break;
					}
					for (int i=0;i<k;i++) {
						X[i] = Double.valueOf(st.nextToken().trim()).doubleValue();
					}
					D.addElement(X.clone());

				}



			}
			if(OK) {
				dataSet ds = new dataSet(N,k,varNames,D);
				try {

					if (r != null) {
						r.newData(ds);

					}

				}

				catch (Exception e){
					message m = new message("\ncall back error");
					m.show();
				}
			}
			data.close();
		}
		catch (IOException e) {
			message m = new message("IO error: " + e.getMessage());
					m.show();
		}

	if(OK)
		setVisible(false);
}
public void setApp(genApp r) {
	this.r=r;

}

}