package analysis;

import RVLS.*;

import java.awt.*;
import java.awt.datatransfer.*;
import java.util.*;
public class rawDataFrame extends closeableFrame implements showDoc
	{
	analysis an;

	public rawDataFrame (analysis an, String data) {
		this.an=an;

		setTitle("Enter data");
			//{{INIT_CONTROLS
		setLayout(null);
		setVisible(false);
		setSize(570,450);
		button2 = new java.awt.Button();
		button2.setLabel("Clear");
		button2.setBounds(416,361,99,38);
		add(button2);
		button1 = new java.awt.Button();
		button1.setLabel("Accept Data");
		button1.setBounds(309,361,99,38);
		add(button1);
		textArea1 = new java.awt.TextArea();
		textArea1.setBounds(29,41,513,310);
		textArea1.setFont(new Font("Monospaced", Font.PLAIN, 12));
		add(textArea1);
		//}}
		//{{INIT_MENUS
		menuBar1 = new java.awt.MenuBar();
		menu1 = new java.awt.Menu("Copy or Paste");
		menuItem1 = new java.awt.MenuItem("Copy Data");
		menu1.add(menuItem1);
		menuItem2 = new java.awt.MenuItem("Paste Data");
		menu1.add(menuItem2);
		menuBar1.add(menu1);
		//setMenuBar(menuBar1);
		//menuBar1.move(0,0)
		//}}
		textArea1.setText(data);
		textArea1.requestFocus();
                try {
		      sysClipBoard = Toolkit.getDefaultToolkit().getSystemClipboard();
                      setMenuBar(menuBar1);
                }
                catch (Exception e)
                {
                  m = new messageCopy("Your internet browser does not allow an applet communicate with clipboard. Please try to use keyborad \"Copy\" or \"Paste\" command to copy date in or paste date out of this \"Enter Data\" frame. If keyboard commands do not work and you want to copy or paste date, please follow the instructions to change your local java.policy file.");
                  m.setInformDoc(this);
                  m.show();
                  //m.requestFocus();
                  this.setLocation(292,0);
                }
		//{{REGISTER_LISTENERS
		SymAction lSymAction = new SymAction();
		button1.addActionListener(lSymAction);
		button2.addActionListener(lSymAction);
		menuItem1.addActionListener(lSymAction);
		menuItem2.addActionListener(lSymAction);
                //m.requestFocus();
		//}}
	}
	//{{DECLARE_CONTROLS
	java.awt.Button button2;
	java.awt.Button button1;
	java.awt.TextArea textArea1;
	//}}
	//{{DECLARE_MENUS
	java.awt.MenuBar menuBar1;
	java.awt.Menu menu1;
	java.awt.MenuItem menuItem1;
	java.awt.MenuItem menuItem2;
        messageCopy m=null;
        //message m;
	//}}
        showDoc showDoc1;
	private Clipboard sysClipBoard;
        public void setInformDoc (showDoc showDoc1)
	{
		this.showDoc1 = showDoc1;
	}
	public void setFocus() {
		textArea1.requestFocus();
	}
	class SymAction implements java.awt.event.ActionListener
	{
		public void actionPerformed(java.awt.event.ActionEvent event)
		{
			Object object = event.getSource();
			if (object == button1)
				button1_ActionPerformed(event);
			else if (object == button2)
				button2_ActionPerformed(event);
			else if (object == menuItem1)
				menuItem1_ActionPerformed(event);
			else if (object == menuItem2)
				menuItem2_ActionPerformed(event);
		}
	}

	void button1_ActionPerformed(java.awt.event.ActionEvent event)
	{
		dataSet ds= readTextArea(textArea1.getText());
		if (ds != null) {

			an.newData(ds);
			an.description(textArea1.getText(),2);
                        if (m!=null)
                          m.dispose();


			setVisible(false);
			this.dispose();
		}
	}

public dataSet readTextArea(String s) {
	int i1=0;
	StringTokenizer st;
	int k,L;
	String line="";
	int begin,end;
	boolean t = true;
	Vector D = new Vector(50);
	Vector varNames = new Vector(5);
	boolean OK=true;
	if (s.length() == 0)
	 	s = "a b c\n 1 2 3 \n 4 5 6";

	 L = s.indexOf("\n",i1);

	 if (L != -1) {
                while (line.trim().equals(""))
                {
                  line = s.substring(i1,L);
                  i1=L+1;
                  L = s.indexOf("\n",i1);
                }
	}
	else  return null;

	st = new StringTokenizer(line);
	k = st.countTokens();
	double [] X = new double [k];
	String [] vNames = new String[k];

	for (int i=0;i<k;i++) {
		String vn = st.nextToken();
		varNames.addElement(vn);
		vNames[i]= vn;
	}
	//boolean test = true;

	try {
		for (int i=0;i<k;i++) {
			double testD = Double.valueOf(vNames[i].trim()).doubleValue();
		}
		//System.out.println("no labels");
		//test = false;
		i1=0;
		varNames.removeAllElements();
		for (int i=0;i<k;i++) {
			varNames.addElement("var" + (i+1));
		}

	}
	catch (Exception e){
	//	System.out.println("labels");
	}


	int N=0;
	while (t) {
		L = s.indexOf("\n",i1);
			if (L != -1) {
				line = s.substring(i1,L);
				i1=L+1;
			}
			else {
				line = s.substring(i1);
				t = false;
			}
		if (line.length() !=0) {
			N++;
			st = new StringTokenizer(line);
			int nt = st.countTokens();
			if (nt != k) {
				message m = new message("Data line " + N + " has " + nt + " item(s) when it should have " + k + ".\n" + line);
				m.show();
				OK=false;
				break;
			}
			for (int i=0;i<k;i++) {
				X[i] = Double.valueOf(st.nextToken().trim()).doubleValue();
			}
			D.addElement(X.clone());
		}
	}
	dataSet ds;
	if (OK)
		ds = new dataSet(N,k,varNames,D);
	else
		ds=null;
	return ds;
}

	void button2_ActionPerformed(java.awt.event.ActionEvent event)
	{
		textArea1.setText("");
	}
	public void copyIt(TextArea ta) {
		String text = ta.getSelectedText();
		if(text.equals("")) text = ta.getText();
		StringSelection sel = new StringSelection(text);
		sysClipBoard.setContents(sel,null);
	}
	public void pasteIt(TextArea ta) {
		String text;
		Transferable sel = sysClipBoard.getContents(this);
		{try
			{text = (String) (sel.getTransferData(DataFlavor.stringFlavor));
			int st = ta.getSelectionStart();
			int end = ta.getSelectionEnd();
			ta.replaceRange(text,st,end);
			}
		catch (Exception e) {}
		}
	}

	void menuItem1_ActionPerformed(java.awt.event.ActionEvent event)
	{
		copyIt(textArea1);
	}

	void menuItem2_ActionPerformed(java.awt.event.ActionEvent event)
	{
		pasteIt(textArea1);
	}
        public void showHtml()
	{
		System.out.println("show Doc do rawdataFrame here.");
                showDoc1.showHtml();
	}
}

