package analysis;

import RVLS.*;

import java.awt.*;

	import java.util.*;
public class residFrame extends closeableFrame  {

	double [] X,Y,YP,YR;
	String xlab, ylab;
	int N;
	// int sOffSet=10;
	//final int scatterY=35;
	//final int scatterW= 375;
	//final int scatterH=350;
	public  residFrame(double [] X, double [] Y, double b, double A,
		String xlab, String ylab)
	{
	this.X=X;
	this.Y=Y;
	this.xlab=xlab;
	this.ylab=ylab;
	N=X.length;
	YP=new double[N];
	YR=new double[N];

	setTitle("Residual Analysis");

			//{{INIT_CONTROLS
		setLayout(null);
		setVisible(false);
		setSize(701,461);
		setBackground(new Color(16449489));
		label4 = new java.awt.Label("",Label.CENTER);
		label4.setBounds(386,365,263,25);
		add(label4);
		label3 = new java.awt.Label("X-axis:",Label.RIGHT);
		label3.setBounds(61,395,69,36);
		add(label3);
		Group1 = new CheckboxGroup();
		radioButton2 = new java.awt.Checkbox("Y'", Group1, false);
		radioButton2.setBounds(210,401,48,24);
		add(radioButton2);
		radioButton1 = new java.awt.Checkbox("X", Group1, true);
		radioButton1.setBounds(144,401,48,25);
		add(radioButton1);
		label2 = new java.awt.Label("",Label.CENTER);
		label2.setBounds(62,359,263,22);
		add(label2);
		label1 = new java.awt.Label("");
		label1.setBounds(21,25,263,28);
		add(label1);
		rawHist1 = new RVLS.rawHist();
		rawHist1.setBounds(356,57,319,298);
		rawHist1.setBackground(new Color(16777215));
		add(rawHist1);
		scatter1 = new RVLS.scatter();
		scatter1.setBounds(20,54,306,305);
		scatter1.setBackground(new Color(16777215));
		add(scatter1);
		//}}
		//{{INIT_MENUS
		//}}
		for (int i=0;i<N;i++) {
			YP[i]=b*X[i]+A;
			YR[i]=Y[i] - YP[i];
		}
		label1.setText(ylab + " - " + ylab + " predicted");
		label4.setText(ylab + " - " + ylab + " predicted");
		doX();
		rawHist1.setData(YR);
		rawHist1.setColor(Color.blue);
		//{{REGISTER_LISTENERS
		SymItem lSymItem = new SymItem();
		radioButton1.addItemListener(lSymItem);
		radioButton2.addItemListener(lSymItem);
		//}}
	}
	//{{DECLARE_CONTROLS
	java.awt.Label label4;
	java.awt.Label label3;
	java.awt.Checkbox radioButton2;
	CheckboxGroup Group1;
	java.awt.Checkbox radioButton1;
	java.awt.Label label2;
	java.awt.Label label1;
	RVLS.rawHist rawHist1;
	RVLS.scatter scatter1;
	//}}
	//{{DECLARE_MENUS
	//}}
	void doX(){
		label2.setText(xlab);
		scatter1.setData(X,YR);

	}
	class SymItem implements java.awt.event.ItemListener
	{
		public void itemStateChanged(java.awt.event.ItemEvent event)
		{
			Object object = event.getSource();
			if (object == radioButton1)
				radioButton1_ItemStateChanged(event);
			else if (object == radioButton2)
				radioButton2_ItemStateChanged(event);
		}
	}

	void radioButton1_ItemStateChanged(java.awt.event.ItemEvent event)
	{
		doX();
	}

	void radioButton2_ItemStateChanged(java.awt.event.ItemEvent event)
	{
		label2.setText(ylab + " predicted");
		scatter1.setData(YP,YR);
	}
}