package analysis;

import RVLS.*;

import java.awt.*;

import java.util.*;
import VisualNumerics.math.Statistics;

public class onetFrame extends confFrame {
	public onetFrame(double [] X, String dv) {
		super();
		d = new desc(X);
		N=d.n;
		compute();
		labelDesc.setText("Confidence Interval on the Mean for " + dv);

	}
	public void compute() {
		try {
			 nh =  Double.valueOf(textFieldNh.getText().trim()).doubleValue();
			}
			catch (NumberFormatException e) {
				message alert1 = new message("Null hypothesis is not a valid number.");
				alert1.show();
			}
		labelEST.setText(graphUtilities.format(d.mean,4));
		//labelSE.setText(graphUtilities.format(d.sem,4));
		double cvSe = d.sem*Statistics.inverseTCdf(0.5*sigLevel, (double)(N-1)); //sqrt(probFandT.Finv(sigLevel,1,N-1));
                //message m = new message("sigLevel="+0.05+", N-1="+5.0+", cvSe="+Statistics.inverseTCdf(0.025, 5.0));
                //m.show();
		double LL = d.mean+cvSe;
		double UL = d.mean - cvSe;
		double t = (d.mean - nh)/d.sem;
		double p = Statistics.tCdf(t,N-1);
                if (p>0.5) p = 2.0*(1-p);
                else p = 2.0*p;
		labelLL.setText(graphUtilities.format(LL,4));
		labelUL.setText(graphUtilities.format(UL,4));
		labelT.setText(graphUtilities.format(t,4));
		labelP.setText(graphUtilities.format(p,4));

	}
	desc d;
	int N,df;
	double nh=0;
}
