package rrange;

import RVLS.*;

import java.awt.*;
import java.awt.datatransfer.*;
import java.util.*;
public class rawDataFrame extends closeableFrame {
dataFrameInt an;

	public rawDataFrame(dataFrameInt an, String data)
        {
		this.an=an;
		setTitle("Enter Data");
			//{{INIT_CONTROLS
		setLayout(null);
		setVisible(false);
		setSize(570,450);
		label1 = new java.awt.Label("In the following data area, please enter X, Y values into two seperate columns, start with X's value then", Label.LEFT);
		label1.setBounds(30,40,540,20);
		add(label1);
                label1 = new java.awt.Label("the Y's value, one line for each pair of the data.", Label.LEFT);
                label1.setBounds(30,60,540,20);
		add(label1);
		button2 = new java.awt.Button();
		button2.setLabel("Clear");
		button2.setBounds(70,390,100,38);
		add(button2);
		button1 = new java.awt.Button();
		button1.setLabel("Accept Data");
		button1.setBounds(235,390,100,38);
		add(button1);
		button3 = new java.awt.Button();
		button3.setLabel("Close");
		button3.setBounds(400,390,100,38);
		add(button3);
		textArea1 = new java.awt.TextArea();
		textArea1.setBounds(30,80,510,300);
		textArea1.setFont(new Font("Monospaced", Font.PLAIN, 12));
		add(textArea1);
		//}}
		//{{INIT_MENUS
		menuBar1 = new java.awt.MenuBar();
		menu1 = new java.awt.Menu("Copy or Paste");
		menuItem1 = new java.awt.MenuItem("Copy Data");
		menu1.add(menuItem1);
		menuItem2 = new java.awt.MenuItem("Paste Data");
		menu1.add(menuItem2);
		menuBar1.add(menu1);
		//$$ menuBar1.move(0,0);
		//}}
		//textArea1.setText(data);
		textArea1.requestFocus();
                try {
		      sysClipBoard = Toolkit.getDefaultToolkit().getSystemClipboard();
                      setMenuBar(menuBar1);
                }
                catch (Exception e)
                {
                  message m = new message("Your internet browser does not allow an applet communicate with clipboard. Please try to use keyborad \"Copy\" or \"Paste\" command to copy date in or paste date out of this \"Data Set\" frame. If your keyboard commands do not work and you want to copy or paste date, then you need to change your local java policy file. To do so, plesae open the instructions on the following URL: \n\nhttp://psych.rice.edu/online_stat/joan/CopyInstructions.html");
                    m.show();
                  //m.requestFocus();
                  this.setLocation(292,0);
                }
		//{{REGISTER_LISTENERS
		SymAction lSymAction = new SymAction();
		button1.addActionListener(lSymAction);
		button2.addActionListener(lSymAction);
                button3.addActionListener(lSymAction);
		menuItem1.addActionListener(lSymAction);
		menuItem2.addActionListener(lSymAction);
                //m.requestFocus();
		//}}
	}
	//{{DECLARE_CONTROLS
	java.awt.Label label1;
        java.awt.Label label2;
	java.awt.Button button2;
	java.awt.Button button1;
	java.awt.Button button3;
	java.awt.TextArea textArea1;
	//}}
	//{{DECLARE_MENUS
	java.awt.MenuBar menuBar1;
	java.awt.Menu menu1;
	java.awt.MenuItem menuItem1;
	java.awt.MenuItem menuItem2;
	//}}
        notified myNotify;
	private Clipboard sysClipBoard;
        dataSet ds=null;
        public void setNotified(notified myNotify)
	{
		this.myNotify = myNotify;
	}
	public void setFocus() {
		textArea1.requestFocus();
	}
	class SymAction implements java.awt.event.ActionListener
	{
		public void actionPerformed(java.awt.event.ActionEvent event)
		{
			Object object = event.getSource();
			if (object == button1)
				button1_ActionPerformed(event);
			else if (object == button2)
				button2_ActionPerformed(event);
                        else if (object == button3)
				button3_ActionPerformed(event);
			else if (object == menuItem1)
				menuItem1_ActionPerformed(event);
			else if (object == menuItem2)
				menuItem2_ActionPerformed(event);
		}
	}

	void button1_ActionPerformed(java.awt.event.ActionEvent event)
	{
		ds= readTextArea(textArea1.getText());
		if (ds != null) {
                        setLocation(550, 0);
			an.newData(ds);
		}
	}
        void button3_ActionPerformed(java.awt.event.ActionEvent event)
	{
		//myNotify.dataChanged(0);
                setVisible(false);
                this.dispose();
	}

public dataSet readTextArea(String s) {
	int i1=0;
	StringTokenizer st;
	int k,L;
	String line;
	int begin,end;
	boolean t = true;
	Vector D = new Vector(50);
	Vector varNames = new Vector(5);
	boolean OK=true;
	if (s.length() == 0)
	 	s = "a b c\n 1 2 3 \n 4 5 6";

	 L = s.indexOf("\n",i1);

	 if (L != -1) {
		line = s.substring(i1,L);
		i1=L+1;
	}
	else  return null;

	st = new StringTokenizer(line);
	k = st.countTokens();
	double [] X = new double [k];
	String [] vNames = new String[k];

	for (int i=0;i<k;i++) {
		String vn = st.nextToken();
		varNames.addElement(vn);
		vNames[i]= vn;
	}
	//boolean test = true;

	try {
		for (int i=0;i<k;i++) {
			double testD = Double.valueOf(vNames[i].trim()).doubleValue();
		}
		//System.out.println("no labels");
		//test = false;
		i1=0;
		varNames.removeAllElements();
		for (int i=0;i<k;i++) {
			varNames.addElement("var" + (i+1));
		}

	}
	catch (Exception e){
	//	System.out.println("labels");
	}


	int N=0;
	while (t) {
		L = s.indexOf("\n",i1);
			if (L != -1) {
				line = s.substring(i1,L);
				i1=L+1;
			}
			else {
				line = s.substring(i1);
				t = false;
			}
		if (line.length() !=0) {
			N++;
			st = new StringTokenizer(line);
			int nt = st.countTokens();
			if (nt != k) {
				message m = new message("Data line " + N + " has " + nt + " item(s) when it should have " + k + ".\n" + line);
				m.show();
				OK=false;
				break;
			}
			for (int i=0;i<k;i++) {
				X[i] = Double.valueOf(st.nextToken().trim()).doubleValue();
			}
			D.addElement(X.clone());
		}
	}
	dataSet ds;
	if (OK)
		ds = new dataSet(N,k,varNames,D);
	else
		ds=null;
	return ds;
}

	void button2_ActionPerformed(java.awt.event.ActionEvent event)
	{
		textArea1.setText("");
                //myNotify.dataChanged(0);
	}
	public void copyIt(TextArea ta) {
		String text = ta.getSelectedText();
		if(text.equals("")) text = ta.getText();
		StringSelection sel = new StringSelection(text);
		sysClipBoard.setContents(sel,null);
	}
	public void pasteIt(TextArea ta) {
		String text;
		Transferable sel = sysClipBoard.getContents(this);
		{try
			{text = (String) (sel.getTransferData(DataFlavor.stringFlavor));
			int st = ta.getSelectionStart();
			int end = ta.getSelectionEnd();
			ta.replaceRange(text,st,end);
			}
		catch (Exception e) {}
		}
	}

	void menuItem1_ActionPerformed(java.awt.event.ActionEvent event)
	{
		copyIt(textArea1);
	}

	void menuItem2_ActionPerformed(java.awt.event.ActionEvent event)
	{
		pasteIt(textArea1);
	}

}

