package reglines;

import java.awt.*;
import RVLS.*;
public class xCanvas extends Canvas {
	int numLines=0;
	Font font;
	FontMetrics met;
	int yinc;
	final int x1End = 100;
	final int x2End = 200;
	boolean regLine=false;
	double mse=0.0;
	double [] sse = new double[11];
	/*Color [] lineColor = {Color.red,  Color.green,
		 Color.orange, Color.pink,Color.magenta, new Color(10485509),
			new Color(16731655), Color.cyan, Color.yellow, new Color(15765503), Color.black};*/
	Color [] lineColor = {Color.red,  Color.green,
		 Color.orange, Color.pink,Color.magenta, new Color(10485509),
			new Color(16731655), Color.cyan, new Color(13290751), Color.gray, Color.black};
	public xCanvas () {
		font = new Font("Helvetica", Font.BOLD, 12);
		setFont(font);
		met=getFontMetrics(font);
		yinc = met.getHeight()+3;
	}

	public void paint (Graphics g) {
		g.drawRect(1,1,getSize().width-2,getSize().height-2);
		int y = yinc+1;
		int x=getSize().width-4;
		//int end = x1End;
		for (int i = 0;i<numLines;i++) {
			g.setColor(lineColor[i]);
			String s = graphUtilities.format(sse[i],0);
			int w = met.stringWidth(s+"  ");
                        g.drawString(s,x-w,y);
			y+=yinc;
			/*g.drawString(s,x,y);
			x = x + w;*/
		}
		if(regLine) {
                        g.setColor(lineColor[10]);
                        String s = graphUtilities.format(mse,0);
                        int w = met.stringWidth(s+"  ");
                        g.drawString(s,x-w,y);
		}
	}
	public void lineAdded(double e) {
		sse[numLines]=e;
		numLines++;
		repaint();
	}
	public void setCurrLine(int currline) {
		numLines = currline;
		if (numLines==0) regLine = false;
		repaint();
	}
	public void setRegLine(double mse) {
		this.mse = mse;
		regLine = true;
		repaint();
	}
	public void setRegLine(boolean regLine) {
		this.regLine = regLine;
		repaint();
	}


}