package repeat;
import java.awt.*;
import RVLS.*;
import java.lang.*;
import java.applet.*;
import java.beans.Beans;

public class rmGraph extends Canvas {
	double [] ya ;
	double [] yb;
	double ymin, ymax;
	double [] t = {0,5,10,15,20};
	int[] Iya;
	int[] Iyb;
	int N=0;
	//int yBottom;


	RVLS.LT LT1;
	boolean drawLines=true;
	final static int XA=45; //XA x coordinates of "Condition A" pts
	final static int XB=185; //XB x coordinates of "Condition B" pts
	final static int YMAXPIX=220; //max value of y coor of pts in pixels
	final static int YMINPIX=10; //min value of y coor of pts in pixels

	Dimension d;

	reg reg1;
	Font f = new Font("TimesRoman",Font.BOLD,16);

	public rmGraph() {

	}

	void setData(double [] ya, double [] yb,int _N, boolean _draw) {
		N=_N;
		if (N>0) {
		drawLines = _draw;
		ymin = ya[0];
		ymax = ya[0];
		for (int i=0;i<N;i++) {
		ymin = Math.min(ymin,ya[i]);
		ymin = Math.min(ymin,yb[i]);
		ymax = Math.max(ymax,ya[i]);
		ymax = Math.max(ymax,yb[i]);
		}
		ymin-=1;
		ymax+=1;
                Graphics g= getGraphics();
		t = Yaxis.ticks(ymin, ymax,YMAXPIX,YMINPIX,g);
		//System.out.println(ymin + " " + ymax);
		LT1= new RVLS.LT(t[0],t[t.length-1],YMAXPIX,YMINPIX);
		Iya = new int[N];
		Iyb = new int[N];
		Iya = LT1.ItransformArray(ya);
		Iyb = LT1.ItransformArray(yb);
		}
		repaint();
	}

	public void update(Graphics g) {
	Dimension dim = getSize();
	Image osi=createImage(dim.width,dim.height);
	Graphics osg=osi.getGraphics();
	osg.setColor(getBackground());
	osg.fillRect(0,0,dim.width,dim.height);
	osg.setColor(g.getColor());
	paint(osg);
	g.drawImage(osi,0,0,this);
}
	public void paint (Graphics g) {


			if (drawLines) {
				for (int i=0;i<N;i++) {
				g.drawLine(XA,Iya[i],XB,Iyb[i]);
				}
			}
			g.setColor(Color.blue);
			for (int i=0;i<N;i++) {
				g.fillOval(XA-2,Iya[i]-2,4,4);
				g.fillOval(XB-2,Iyb[i]-2,4,4);
			}
			g.setColor(Color.black);
			Yaxis.drawYaxis(YMAXPIX,YMINPIX,XA-10,t,0,g);
			g.drawLine(XA-10,YMAXPIX,325,YMAXPIX);  //Draw x-axis
			g.drawString("A",XA-3,YMAXPIX+16);
			g.drawString("B",XB-3,YMAXPIX+16);

			if (java.beans.Beans.isDesignTime()) {
				Dimension d = getSize();
				g.drawRect(0,0,d.width-1,d.height-1);
			}
	}
}