package sampdist;

import java.awt.*;
import java.applet.Applet;
import java.util.*;
import RVLS.*;

public class Sampling extends Frame implements notified
{
	//float[] a= {5,3,1,2,3,9,7,6,4};

	sampleMany stx;
	Histogram h,hh,hhh,hhhh;
        MoveRect mr,mr2,mr3,mrN2;
	Panel P1,P2,P3,P4;
	gapButton b;
	dataButton db;
	clearButton cb;
	sampleButton db2;
	sampleButton2 db3;
	sampleButton3 db4;
	sampleButton4 db5;
        Label samplelabel;
	String theDist;
	int hHeight,yintervals;
	int hWidth = 476;
	int N = 5; //sample size
	int N2 =5;
	int k; //number of bins
	int ns=0; //number of sample statistics
	int ns2=0;
	final int sampMax = 10000; // maximum sample size
	float[] xdata,xdata2; //xdata is x scale for histograms; xdata2 is special for variances
	float[] statD,statD2;
	double temp;
	//double[] stats;
	//float[] SampleData;
	int[] sampleFdata;
	int[] fdata;
	//Color color4,color3;
	Color[] colors = {Color.blue,Color.magenta,Color.red,Color.green,Color.black, Color.cyan, Color.darkGray, Color.darkGray,Color.lightGray};
	Color distColor=Color.darkGray;
	final int [] normdata = {2,3,3,6,8,14,19,32,45,60,78,97,116,133,147,156,160,156,147,133,116,97,78,60,45,32,19,14,8,6,3,3,2};
;
	int[] skewedData;

	//int[] skewedData = {5,5,5,5,6,8,10,12,14,16,18,16,15,10,8,7,6,5,5,5,5,5,4,4,4,4,3,3,3,3,2,2,2,2,2,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1};
	//int[] fdata ={1,1,1,1,1,1,2,4,6,7,8,9,9,10,11,11,12,11,11,10,9,9,8,7,6,5,4,4,2,2,2,1,1,1,1};
	public String astring, statName1,statName2;
	public Label mean;
	public Choice dist,sampleSize,sampleSize2,stat,stat2c;
	Checkbox fit1,fit2;
	boolean[] statsOn, stats;

	public  Sampling ()
	{
		setTitle("Sampling Distributions");
		setBackground(parameters.getBackGroundColor());
		Dimension d = java.awt.Toolkit.getDefaultToolkit().getScreenSize();
		//String hs= getParameter("height");
		stx = new sampleMany(this,1,1,1);

		//hHeight = Integer.valueOf(hs).intValue();
		hHeight = Math.min(d.height - 80,600);

		yintervals = (int) Math.round(hHeight/100);
		setSize(620,hHeight);
/*
		Date dxx = new Date();
		int y = dxx.getYear();
		int m = dxx.getMonth();
		if ( (y>98) || (m>5)) {
			//setLayout(null);
			resize(417,284);

			Label expLabel = new Label("Please contact David Lane at: Lane@rice.edu");
			//expLabel.setBounds (10,10,450,12);
			add(expLabel);
		}
	else {
		*/
		hHeight = hHeight/4 -15; // height of one histogram
		statsOn=new boolean[10];
		stats=new boolean[10];
		for (int i=0;i<10;i++){
			statsOn[i]=true;
			stats[i]=false;
		}
		statsOn[3]=false;
		statsOn[5]=false;
		statsOn[6]=false;
                statsOn[8]=false; //joan add
		/*
		0: mean
		1: median
		2: sd
		3: range
		4: skew
		5: mean abs difference
		6: variance
		7: kurtosis
		8: Unbiased variance

		*/
		//setBackground(Color.white);


	//	color4=Color.orange;
	//	color3=Color.magenta;
		statName1="Mean";
		statName2 = "None";
		//resize(600,420);
		//k = hWidth/10;
		//k=34;
		//if (k- Math.floor(k/2)*2 <=0){
		//	k=k-1;
		//}
		k = 33; // number of bins
		setLayout(new FlowLayout(FlowLayout.LEFT));
                //setFont(new Font("TimesRoman",Font.PLAIN,12)); //joan added 10/6/03
		statD = new float[sampMax]; //data for histogram 1
		statD2 = new float[sampMax]; // data for histogram 2
		//statout = new float[5];  //computed statistics
		//stats = new double[10];
		xdata = new float[k];
		xdata2 = new float[k];
		sampleFdata = new int[k];  //used as temp array
	//	normdata = new int[k];     // normally disributed
		skewedData= new int[k];   //skewed
	//	int j;
		fdata = new int[k];   //freq for histogram 1

		//float step2 = Math.round(Math.pow(k-k/2,2)/k);  // scale for variance distrib
		float step2=8;
		//float step2 = Math.round(Math.pow((k-1)/2,2)/(k-1));  // scale for variance distrib
		float s= -step2;
		for (int i=0;i<k;i++){
			//fdata[i] = (int) Math.round(Math.random()*10);
			s+=step2;
			xdata[i] = (float) i;
			xdata2[i] = s;
			//System.out.println(i + " " + xdata2[i]);
		}



		s = k;
		s/=6;
		float mn = k-1;
		mn/=2;

		temp =  Math.sqrt(1.0/(2.0*Math.PI*s*s));
		double z,skewMax;
		skewMax = Math.pow( xdata[k-1], 2);

		for (int i=0;i<k;i++){
			//System.out.println(i);
			z= -1*Math.pow((xdata[i]-mn),2)/(2*s*s);

			z = Math.exp(z)*temp;
			//normdata[i] = (int) Math.round(1000.0*z);
			//System.out.println(xdata[i] + " f(x) = " + z + " normdata " + normdata[i]);
			skewedData[i] = (int) Math.round(Math.pow(xdata[k-i-1],2)/skewMax*5000);
		}
				//skewedData[0]=skewedData[2];


	skewedData[0]=skewedData[6];
	skewedData[1]=skewedData[5];
	skewedData[2]=skewedData[4];


		for (int i = 0;i<k;i++){
			sampleFdata[i]=0;
		}
		theDist=("Normal");
		setDist();

		for (int i = 0;i<k;i++){
			//System.out.println(fdata[i]);
		}

		P1=new Panel();
                //P1.setBounds(486,68,127,52);
		P2=new Panel();
                //P2.setBounds(486,335,127,78);
		P3=new Panel();
                //P3.setBounds(486,475,127,78);
		P4= new Panel();
                //P4.setBounds(486,165,127,130);

		h = new Histogram("Parent populaton (can be changed with the mouse)",xdata,fdata,k,statsOn,false, hWidth,hHeight,yintervals,true,false,0,colors);
		h.setColor(distColor);
                h.setInform(this);
		h.setEndsOnly(true);

		add(h);
		cb = new clearButton(this,"Clear lower 3");
                //cb.setBounds(0,0,120,25);
		P1.add(cb);
		dist = new Choice();
		dist.addItem("Normal");
		dist.addItem("Uniform");
		dist.addItem("Skewed");
		dist.addItem("Custom");
		//dist.setBackground(Color.white);
                dist.setBounds(0,26,120,25);
		P1.setLayout (new GridLayout(0,1));
		P1.add(dist);

		add(P1);


		hh = new Histogram("Sample Data",xdata,sampleFdata,k,stats,true,hWidth,hHeight,yintervals,false,false,0,colors);
		hh.setStats(false);
		hh.setEndsOnly(true);
		add(hh);
                samplelabel = new Label("Sample:", Label.CENTER);
                samplelabel.setFont(new Font("TimesRoman",Font.PLAIN,12));
                P4.add(samplelabel);
		db2 = new sampleButton(this,"Animated");
		P4.add(db2);
		db3 = new sampleButton2(this,"5");
		P4.add(db3);
		db4 = new sampleButton3(this,"1,000");
		P4.setLayout (new GridLayout(0,1));
		P4.add(db4);

		db5 = new sampleButton4(this,"10,000");
		P4.add(db5);
		add(P4);
		sampleSize = new Choice();
		sampleSize.addItem("N=2");
		sampleSize.addItem("N=5");
		sampleSize.addItem("N=10");
		sampleSize.addItem("N=16");
		sampleSize.addItem("N=20");
		sampleSize.addItem("N=25");
		sampleSize.setBackground(Color.white);
		//stats[1]=true;
		hhh = new Histogram("Distribution of Means, N=5",xdata,sampleFdata,k,statsOn,true,hWidth,hHeight,yintervals,false,false,0,colors);

		add(hhh);
		hhh.setEndsOnly(true);
		P2.setLayout (new GridLayout(0,1));

		stat = new Choice();
		stat.addItem("Mean");
		stat.addItem("Median");
		stat.addItem("sd");
		stat.addItem("Variance");
		stat.addItem("Var (U)");
		stat.addItem("MAD");
		stat.addItem("Range");
		stat.setBackground(Color.white);
		fit1 = new Checkbox("Fit normal");

		sampleSize.select("N=5");
		P2.add(stat);
		P2.add(sampleSize);
		P2.add(fit1);

		add(P2);
                //System.out.println("p2="+P2.getLocation());

		hhhh = new Histogram("",xdata,sampleFdata,k,statsOn,true,hWidth,hHeight,yintervals,false,false,0,colors);
		//hhhh.setColor(color4);
		hhhh.setEndsOnly(true);
		add(hhhh);
		sampleSize2 = new Choice();
		sampleSize2.addItem("N=2");
		sampleSize2.addItem("N=5");
		sampleSize2.addItem("N=10");
		sampleSize2.addItem("N=16");
		sampleSize2.addItem("N=20");
		sampleSize2.addItem("N=25");
		sampleSize2.setBackground(Color.white);
		P3.setLayout (new GridLayout(0,1));

		stat2c = new Choice();
		stat2c.addItem("None");
		stat2c.addItem("Mean");
		stat2c.addItem("Median");
		stat2c.addItem("sd");
		stat2c.addItem("Variance");
		stat2c.addItem("Var (U)");
		stat2c.addItem("MAD");
		stat2c.addItem("Range");
		stat2c.setBackground(Color.white);
		fit2 = new Checkbox("Fit normal");

		sampleSize2.select("N=5");
		P3.add(stat2c);
		P3.add(sampleSize2);
		P3.add(fit2);


		add(P3);
//}

			//{{INIT_CONTROLS

		//setSize(430,270);
		//setTitle("Untitled");
		//}}
		//{{INIT_MENUS
		//}}
}
        public void dataChanged(int i)
        {
          //clearAll();
          if (mr!=null) mr.stop();
          if (mr2!=null) mr2.stop();
          if (mr3!=null) mr3.stop();
          if (mrN2!=null) mrN2.stop();
          if (stx!=null) stx.stop();
          clearAll();
        }
	public boolean handleEvent(Event e) {
		if (e.id == e.WINDOW_DESTROY) {
			dispose();
			return true;
		}
		else
			return super.handleEvent(e);
		/*
		switch(e.id) {
			case e.WINDOW_DESTROY:
				dispose();
			default:
				return false;
		}
		*/
		//return true;
	}


	public void clearAll(){
		if (hhh != null ) {hhh.clear();}
		if (hh != null ) {hh.clear();}
		if (hhhh != null ) {hhhh.clear();}
	}

	public void setDist(){
		if (h != null) {
			//h.setClickable(false);
			h.setTitle("Parent populaton (can be changed with the mouse)");
		}
		if (theDist == "Normal") {
			 for (int i=0;i<k;i++){
				fdata[i]=normdata[i];
			}
		}
		else if (theDist == "Uniform"){
			for (int i=0;i<k;i++){
				fdata[i]=15;
			}


		}
		else if (theDist == "Skewed"){
			for (int i=0;i<k;i++){
				fdata[i]=skewedData[i];
			}

		}

		else if (theDist == "Custom"){
			for (int i=0;i<k;i++){
				fdata[i]=0;
			}

			//h.setClickable(true);
			h.setTitle("Paint distribution with mouse.");
		}

		if (!(h==null)) {
			double t1,t2;
			t1=0;t2=0;
			for (int i=0;i<k;i++){
				t1+=xdata[i]*fdata[i];
				t2+=xdata[i]*xdata[i]*fdata[i];
			}
			h.setData(fdata,k,false,t1,t2);
			if (theDist.equals("Custom")) {h.setFmax(40);}
			ns=0;
			//clearAll();
                        if (mr!=null) mr.stop();
                        if (mr2!=null) mr2.stop();
                        if (mr3!=null) mr3.stop();
                        if (mrN2!=null) mrN2.stop();
                        if (stx!=null) stx.stop(); //joan add 10/6/03
                        clearAll();

		}
		setXdata2();


	}
	public void clearData(Histogram H){
		int[] fd2;
		int k;

		if (!(H==null)) {
			k=H.numInt;
			fd2 = new int[k];
			for (int i=0;i<k;i++){
				fd2[i]=0;
			}
			H.setData(fd2,k,false,0,0);
		}
	}
	public boolean action(Event event, Object whatAction){

          //System.out.println("p1="+P1.getBounds()+", p2="+P2.getBounds()+", p3="+P3.getBounds()+" p4="+P4.getBounds());
		if (event.target instanceof Choice) {
			String tstring = (String) whatAction;
			Choice whichChoice = (Choice) event.target;
			if (whichChoice == dist) {
				theDist = tstring;
				setDist ();
				return true;
			}
			else if (whichChoice == sampleSize){
				int in1 = tstring.indexOf('=')+1;
				N=Integer.valueOf(tstring.substring(in1)).intValue();
				hhh.setTitle("Distribution of " + stat.getSelectedItem() +"s, " +  sampleSize.getSelectedItem());

				//if (tstring == "N=2")  {N=2;}
				//else if (tstring == "N=5")  {N=5;}
				//else if (tstring == "N=10")  {N=10;}
				//else if (tstring == "N=25")  {N=25;}
				clearAll();
				ns=0;
				setXdata2();
				return true;
			}
			else if (whichChoice == stat){
				statName1= tstring;

			//	if (statName2.equals("None")) {
/*
				if (tstring.equals("Variance")) {
					//hh.setData(xdata2);
					//setXdata2();
					hhh.setData(xdata2);
					hhhh.setData(xdata2);
				}
				else if (! statName2.equals("Variance")) {
					//hh.setData(xdata);
					//setXdata2();
					hhh.setData(xdata);
					hhhh.setData(xdata);
				}
*/

				hhh.setTitle("Distribution of " + tstring +"s, " + sampleSize.getSelectedItem());
				clearAll();
				ns=0;
				setXdata2();
				return true;
			}
		else if (whichChoice == stat2c){
			statName2= tstring;

			clearAll();
/*
			if (tstring.equals("Variance")) {
				//	hh.setData(xdata2);
					hhh.setData(xdata2);
					hhhh.setData(xdata2);
			}
			else if (! statName1.equals("Variance")){
				//hh.setData(xdata);
				hhh.setData(xdata);
				hhhh.setData(xdata);

			}
*/
			ns2=0;
			if (tstring.equals("None")){
				hhhh.setTitle("");
			}
			else {
				//hhhh.setTitle("Distribution of " + tstring +"s");
				hhhh.setTitle("Distribution of " + stat2c.getSelectedItem() +"s, " +  sampleSize2.getSelectedItem());

			}
			setXdata2();
			return true;
		}
		else if (whichChoice == sampleSize2){
				int in1 = tstring.indexOf('=')+1;
				N2=Integer.valueOf(tstring.substring(in1)).intValue();
				hhhh.setTitle("Distribution of " + stat2c.getSelectedItem() +"s, " +  sampleSize2.getSelectedItem());

			//if (tstring == "N=2")  {N2=2;}
			//else if (tstring == "N=5")  {N2=5;}
			//else if (tstring == "N=10")  {N2=10;}
			//else if (tstring == "N=25")  {N2=25;}

			clearAll();

			ns2=0;
			setXdata2();
			return true;
		}
	}
	if (event.target instanceof Checkbox) {
		//String tstring = (String) whatAction;

		Checkbox cc = (Checkbox) event.target;
		if (cc==fit1){
			boolean cbs = cc.getState();
			hhh.SetNorm(cbs);
			return true;
		}
		else if (cc==fit2){
			boolean cbs = cc.getState();
			hhhh.SetNorm(cbs);
			return true;
		}
	}
		return false;
	}

	/*public void CalcStats (float [] X, int N, float [] statout){
		double mean=0;
		double s=0;
		for (int i =0;i<N;i++){
			mean+=X[i];
			s=s+X[i]*X[i];
		}
		s = Math.sqrt((s - mean*mean/N)/N);
		mean/=N;
		statout[0]=(float) mean;
		statout[1]=(float) s;
	}
	*/
	public void sample1(int s) {
		float stat2,stat1;
		float[] D,D2,statR;
		//MoveRect mr,mr2,mr3,mrN2; joan change 10/5/03
		mr2=null;
		double s1,s2,sq1,sq2;
		s1=0;sq1=0;s2=0;sq2=0;
		int[] speeds,fd2,bottoms,bottoms2,bottoms3,bottomsN2;
		int [] bins,bins2,bins3,binsN2;
		int nsamp, statIndex1,statIndex2;

		statIndex1 = chooseStat(statName1);
		statIndex2=0;
		//Color Scolor;
		stat1=0;
		stat2=0;
		statR = new float[2];
		bottoms = new int[N];
		bottomsN2 = new int[N2];
		bins = new int[N];
		bottoms2 = new int[N];
		bins2 = new int[N];
		binsN2 = new int[N2];


		bins3 = new int[N];
		bottoms3 = new int[N];

//System.out.println("XXX");


		fd2 = new int[k]; // a freq dist

		speeds= new int[4];
		D = new float[N]; //sample for hhh
		D2 = new float[N]; // sample for hhhh
		nsamp=s;

                int sum=0;

                for (int k=0; k<h.fdata.length; k++)
                sum = sum +h.fdata[k];

                if (sum==0)
                {
                  message m= new message("You have not specified a distribution to sample from.\n\nPlease use the mouse to paint a distribution.");
                  m.show();
                  return;
                }


		if (nsamp==1) {
		// One sample means animate
			speeds[0]=5; // small delay to let screen update
			speeds[1] = 5; // delay after rectangle is first drawn
			speeds[2]=3;  // delay between rectangle moves
			//clearData(hh);


			D = sample(fdata,k,N);
			if (N == N2) {
				for (int i=0;i<N;i++){
					D2[i]=D[i];
				}
			}
			else {
				D2 =  sample(fdata,k,N2);
			}
			statR=getStats(D,D2);

			stat1=statR[0];  // stat for hhh;
			stat2=statR[1];  // stat for hhhh


			fd2 = tally(D,xdata,k,N,bins,true);
			// tally data in D  returning the sequence of bins for animation

			for (int i=0;i<N;i++){
				s1+=D[i];
				sq1+=D[i]*D[i];
			}


			bottoms = prepAnimate(hh,bins,N) ; // get bottoms for animation


			fd2=tally(statR,hhh.xdata,k,1,bins2,true);
			bottoms2 = prepAnimate(hhh,bins2,1) ; // animate one stat
			hhh.setStats(false); // don't compute stats during animation
			hhh.sum+=stat1;
			hhh.ssq+=stat1*stat1;
			if (statName2 != "None"){

				for (int i=0;i<N2;i++){
					s2+=D2[i];
					sq2+=D2[i]*D2[i];

				}
				hhhh.sum+=stat2;
				hhhh.ssq+=stat2*stat2;
				statIndex2 = chooseStat(statName2);
				statR[0] = stat2;
				fd2=tally(statR,hhhh.xdata,k,1,bins3,true);
				bottoms3 = prepAnimate(hhhh,bins3,1);
				fd2=tally(D2,xdata,k,N2,binsN2,true);
				bottomsN2 = prepAnimate(hh,binsN2,N2);
			}

				speeds[1]=800; // hold rect for 800 msec in original position

				if (statName2 == "None"){
					mr2 = new MoveRect(hhh,statsOn,1,bottoms2,bins2,speeds,1,false,colors[statIndex1],null);
				}
				else {

					speeds[1]=800;
					mr3 = new MoveRect(hhhh,statsOn,1,bottoms3,bins3,speeds,1,false,colors[statIndex2],null);
					speeds[1]=5;
					//Compute only stat for sampling dist
					for (int i=0;i<stats.length;i++){
						stats[i]=false;
					}
					stats[statIndex2]=true;

					mrN2 = new MoveRect(hh,stats,1,bottomsN2,binsN2,speeds,N2,true,distColor,mr3);
					mrN2.sum=s2;
					mrN2.ssq=sq2;
				//	System.out.println("sample s2 = " + s2);
					speeds[1]=800;
					mr2 = new MoveRect(hhh,statsOn,1,bottoms2,bins2,speeds,1,false,colors[statIndex1],mrN2);
				}

				//ns++;
				speeds[1]=5;

				for (int i=0;i<stats.length;i++){
					stats[i]=false;
				}
				stats[statIndex1]=true;
				mr = new MoveRect(hh,stats,1,bottoms,bins,speeds,N,true,distColor,mr2);
				mr.sum=s1;
				mr.ssq=sq1;

				mr.start();
			}
		//}

	else {
	stx = new sampleMany(this,nsamp,statIndex1,statIndex2);
	stx.start();
}
}
public int chooseStat(String statName) {
		int r=0;
		if (statName=="Mean") {
			 r= 0;
		}
		else if (statName=="Median") {
			r= 1;
		}
		else if (statName=="sd") {
			r= 2;
		}
		else if (statName=="Range") {
			r= 3;
		}
		else if (statName=="MAD") {
			r= 5;
		}
		else if (statName=="Variance") {
			r= 6;
		}
		else if (statName=="Var (U)") {
			r= 8;
		}
	return r;
}
	public void setXdata2() {
		int step, minN;
		step=1;
		//System.out.println("N= " + N + " N2= " + N2 + " statName1= " + statName1 + " statName2= " + statName2);
		if (statName1.indexOf("Var") != -1 || statName2.indexOf("Var") != -1) {

				if (statName2.indexOf("Var") == -1 ) {
					minN = N;
				}
				else if (statName1.indexOf("Var") == -1 ) {
					minN = N2;
				}
				else {
					minN = Math.min(N,N2);
				}

			if (theDist.equals("Custom")) {
				//System.out.println("Custom");
				step = 8;
			}

			else if (theDist.equals("Normal")) {
				//System.out.println("Normal");

				switch (minN) {
					case 2:
						step = 6;
						break;
					case 5:
						step = 4;
						break;
					case 10:
						step = 3;
						break;
					case 16:
						step = 3;
						break;
					case 20:
						step = 2;
						break;
					case 25:
						step = 2;
						break;
					default:
						step = 1;
					}
			}
			else if (theDist.equals("Skewed")) {
				//System.out.println("Skewed");
				switch (minN) {
					case 2:
						step = 8;
						break;
					case 5:
						step = 6;
						break;
					case 10:
						step = 4;
						break;
					case 16:
						step = 4;
						break;
					case 20:
						step = 3;
						break;
					case 25:
						step = 3;
						break;
					default:
						step = 1;
					}
			}
			else if (theDist.equals("Uniform")) {
				//System.out.println("Uniform");
				switch (minN) {
					case 2:
						step = 8;
						break;
					case 5:
						step = 8;
						break;
					case 10:
						step = 6;
						break;
					case 16:
						step = 6;
						break;
					case 20:
						step = 5;
						break;
					case 25:
						step = 5;
						break;
					default:
						step = 1;
					}
			}
		else {
			step = 1;
		}


	}
		for (int i=1;i<k;i++) {
			xdata2[i] = xdata2[i-1] + step;
		}
		if (hhh!= null) {hhh.setData(xdata2);}
		if (hhhh != null) {hhhh.setData(xdata2);}
			//System.out.println("Step = " + step);
}

	public float[] getStats (float[] D, float[] D2) {
			float[] R;

			//D = new float[N];
			//D2=new float[N2];
			R= new float[2];

			R[0] = getStat(statName1,D,N);

			R[1] = getStat(statName2,D2,N2);

		return R;
		}
	public float getStat (String statName, float[] D, int NN){
			float R;
			R=0;



			if (statName=="Mean") {
				R= (float) ComputeMean(D,NN);
			}

			else if (statName=="Range") {
				R= (float) ComputeRange(D,NN);

			}

			else if (statName=="Median") {
				R= (float) ComputeMedian(D,NN);

			}
			else if (statName=="sd") {
				R= (float) Computesd(D,NN);

			}
			else if (statName=="MAD") {
				R= (float) ComputeMAD(D,NN);

			}
			else if (statName=="Variance") {
				//System.out.println("Call  Computesd from variance");
				R= (float) computeVar(D,NN);

			}
			else if (statName=="Var (U)") {
				//System.out.println("Call  Computesd from variance");
				R= (float) computeVar(D,NN)*N/(N-1);

			}
			return R;
	}


 public double computeVar (float[] X, int N) {
 	float s,sq;
 	s=0;
 	sq=0;
 	for (int i=0;i<N;i++){
 		s+=X[i];
 		sq+=X[i]*X[i];
 	}
 	sq = (sq-s*s/N)/N;
 	return sq;
 }

public double ComputeMAD (float[] X, int N) {
		double MAD;
		int[] fd = new int[k];
		fd = tally(X,xdata,k,N,fd,false);
		MAD= h.ComputeMAD(fd,h.xdata,k);
	return MAD;
}

	public double ComputeMean(float[] X, int N){
		double s;
		s=0;
		for(int i=0;i<N;i++){
			s+=X[i];
		}
		s/=N;
		return s;
	}

	public double ComputeRange(float[] X, int N){
		//double amin,amax;
		/*amin=X[0];
		amax=X[0];
		for(int i=1;i<N;i++){
			amin = Math.min(amin,X[i]);
			amax = Math.max(amax,X[i]);
		}
		double r = amax-amin;
		return r;
		*/
		int[] fd = new int[k];
			fd = tally(X,xdata,k,N,fd,false);
			double r= h.ComputeGroupedRange(fd,xdata,k);
			return r;
	}


	public double ComputeMedian(float[] X, int N){
		double med;
		int m;
		m=N/2;

			int[] fd = new int[k];
			fd = tally(X,xdata,k,N,fd,false);
			med= h.ComputeGroupedMedian(fd,k,N);


		return med;

	}



public double Computesd(float[] X, int N){
		double s,sq;
		s=0;
		sq=0;
		for(int i=0;i<N;i++){
			s+=X[i];
			sq+=X[i]*X[i];
		}
		s=Math.sqrt((sq-s*s/N)/N);

		return s;
	}


		public int[] prepAnimate(Histogram H, int[] bins, int N){
			//System.out.println("prep begin");
			double s,intercept;
			int w,j;
			int[] bottoms;
			bottoms = new int[N];
			s=H.sv2p;
			w=H.width;
			//float step = H.xdata[1] - H.xdata[0];
			//float x0 = H.xdata[0] - step/2;
			intercept = H.inter;
			for (int i = 0;i<k;i++){
				sampleFdata[i]=H.fdata[i];
			}

			for (int i = 0;i<N;i++){
				j=bins[i];
				//bottoms[i]= (int) (s*sampleFdata[j] +s + intercept);
				bottoms[i]= (int) (s*sampleFdata[j]  + s+ intercept + H.yoffset2);

				sampleFdata[j]++;
				//System.out.println("j= " + j + "new freq = " + sampleFdata[j]  + " bottom = " + bottoms[i]);
				//System.out.println("i= " + i + " bottom = " + bottoms[i]);
			}
			//System.out.println("prep done");
			return bottoms;
		}
	public int[] tally (float[] rawdata, float[] xd,int k, int N, int[] bins, boolean saveBins){
		//System.out.println("Tally begin");
		int j;
		int[] freqData;
		freqData = new int[k];
		for (int i = 0;i<k;i++){
			freqData[i]=0;
		}
	//	System.out.println("tally");
		float step = xd[1]-xd[0];
		//float x0 = xd[0] - step/2;

		for (int i=0;i<N;i++){
			//j = (int) Math.floor(rawdata[i]-x0)/step);
			j = Math.min((int) Math.max(Math.round(rawdata[i]/step),0),k-1);
			//if (j==k-2) System.out.println(i + " " + j + " " + rawdata[i]);
			//System.out.println(i + " " + j + " " + rawdata[i]);
			if (saveBins) {bins[i]=j;}
			freqData[j]++;
		}
		//System.out.println("Tally end");
		return freqData;
	}

	public synchronized float[] sample(int[] fd,int k, int n){
	  	int[] c;
	  	//int[] SampleFd;
	  	float [] SampleData1;
	  	int nn,z,ri;
	  	nn=k; // number of bins
	  	z=0;
	  	SampleData1 = new float[n];
	  	//SampleFd = new int[k];
	  	float step2 = (xdata[1]-xdata[0])/2;
	  	c = new int[nn];
	  	//System.out.println("xxxxxxxxxx");
	  	for (int i=0;i<nn;i++){
	  		z+=h.fdata[i];
	  		c[i]=z;
	  		//System.out.println(i + " " + c[i]);
	  	}

		for (int i=0;i<n;i++){
		//	System.out.println("i= " + i);
	  		ri = (int) Math.floor(Math.random()*z) +1;
	  		//System.out.println(ri);
	  		for (int j = 0;j<k;j++){
	  			if (ri <= c[j]) {
	  				SampleData1[i] = xdata[j];
	  				SampleData1[i]+= (Math.random() - 0.5)*step2;
	  				//System.out.println("ri = " + ri + " j= " + j);
	  				break;
	  			}
	  		}
	  	}
	  //	for (int i=0;i<n;i++){
	  	//	System.out.println( i + " " + SampleData1[i]);
	 // 	}
	  	//SampleFd = tally(SampleData,k,n);
		return SampleData1;
	}

	/*public int[] newFreq(int[] fd,int k, int n){
		float [] SampleData1;
		SampleData1 = new float[n];
	  	SampleData1 = sample(fd,k,n);
	  	return  tally(SampleData1,k,n);
	}
	*/
	public void paint(Graphics g)
	{
		//g.setColor(Color.blue);
		//g.drawString(astring, 25, 125 );
	}
	//{{DECLARE_CONTROLS
	//}}
	//{{DECLARE_MENUS
	//}}
}

class gapButton extends Button {
	Sampling applet;
	int g;
		public gapButton(Sampling a,int gg, String label)
		{
			super(label);
			applet=a;
			g=gg;
			setBackground(Color.white);
		}

		public boolean action(Event e, Object arg)
		{
			//System.out.println("g= " + g);
			applet.h.setGap(g);
			return false;
		}
	}

	class clearButton extends Button {
	Sampling applet;
		public clearButton(Sampling a, String label)
		{
			super(label);
			applet=a;
			setBackground(Color.white);

		}

		public boolean action(Event e, Object arg)
		{
			//System.out.println("g= " + g);
			applet.clearAll();
			return true;
		}
	}

	class dataButton extends Button {
	//Sampling applet;
	Histogram histo;
	int n;
	int[] newData;
		public dataButton(int gg,Histogram hh, String label)
		{
			super(label);
			//applet=a;
			n=gg;
			histo=hh;
			setBackground(Color.white);

		}

		public boolean action(Event e, Object arg)
		{
			newData = new int[n];
			for (int i=0;i<n;i++){
			newData[i] = (int) Math.round(Math.random()*10);

		}
			histo.setData(newData,n,false,0,0);
			return true;
		}
	}
class sampleButton extends Button {
	Sampling applet;
	public sampleButton(Sampling a,String label){
		super(label);
		applet=a;
		setBackground(Color.white);

	}
		public boolean action(Event e, Object arg) {
			applet.sample1(1);
			return true;
	}
}

class sampleButton2 extends Button {
	Sampling applet;
	public sampleButton2(Sampling a,String label){
		super(label);
		applet=a;
		setBackground(Color.white);

	}
		public boolean action(Event e, Object arg) {
			//System.out.println(" #2 " );
			applet.sample1(5);
			return true;
	}
}

class sampleButton3 extends Button {
	Sampling applet;
	public sampleButton3(Sampling a,String label){
		super(label);
		applet=a;
		setBackground(Color.white);

	}
		public boolean action(Event e, Object arg) {
			//System.out.println(" #2 " );
			applet.sample1(1000);
			return true;
	}
}
class sampleButton4 extends Button {
	Sampling applet;
	public sampleButton4(Sampling a,String label){
		super(label);
		applet=a;
		setBackground(Color.white);

	}
		public boolean action(Event e, Object arg) {
			//System.out.println(" #2 " );
			applet.sample1(10000);
			return true;
	}
}

class sampleMany implements Runnable {
	Sampling s;
	fWait f;
	int nsamp, statIndex1, statIndex2;
	Thread SampleT;
	float[] D,D2,statR;
	int [] fd2;
	double s1,s2,sq1,sq2;
	public sampleMany(Sampling _s, int _nsamp,int _statIndex1, int _statIndex2) {
		s=_s;
		nsamp=_nsamp;
		statR = new float[2];
		D = new float[s.N]; //sample for hhh
		D2 = new float[s.N2]; // sample for hh
		s1=0;sq1=0;s2=0;sq2=0;
		statIndex1=_statIndex1;
		statIndex2=_statIndex2;
		fd2 = new int[s.k];

	}
	public void start(){
		if(nsamp > 9) {f = new fWait("Please wait");}
		//h.mRect[3]=h.yinc;
		//System.out.println("starting");
		SampleT = new Thread(this);
		SampleT.start();
	}
	public void run()
	{
		s.hh.clear();
		s.ns=0;
		int N2=s.N2;
		//double sa=0;
		statR[0]=0;statR[1]=0;
		for (int i = 0;i<nsamp;i++){
			D = s.sample(s.fdata,s.k,s.N);
			if (s.statName2 != "None"){
				if (s.N == N2) {
					for (int j = 0; j<N2; j++) {
						D2[j]=D[j];
					}
				}
			else {

				D2 =  s.sample(s.fdata,s.k,s.N2);
			}
			}
				//System.out.println("about to getStats");
				statR=s.getStats(D,D2);
				s.statD2[s.ns]=statR[1];
				s.statD[s.ns]=statR[0];
				s1+=statR[0];
				sq1+=statR[0]*statR[0];
				s2+=statR[1];
				sq2+=statR[1]*statR[1];

				s.ns++;

				if ((i%200 == 0) && (nsamp > 9)) {
					int left = nsamp-i;
					f.setLabel("Samples left : " + left);
					//System.out.println(i);
					try {Thread.sleep(8);} catch (Exception e){}
				}
		}
		int[] dummy = new int[s.k];
		fd2 = s.tally(s.statD,s.hhh.xdata,s.k,s.ns,dummy,false);


		s.hhh.setColor(s.colors[statIndex1]);
		s.hhh.setData(fd2,s.k,true,s1,sq1);
//System.out.println(s.statName2);
		if (! s.statName2.equals("None")){
//			System.out.println("ne None");
			statIndex2 = s.chooseStat(s.statName2);

			s.hhhh.setColor(s.colors[statIndex2]);
			fd2 = s.tally(s.statD2,s.hhhh.xdata,s.k,s.ns,dummy,false);
			s.hhhh.setData(fd2,s.k,true,s2,sq2);

			if (s.hhhh.fmax>s.hhh.fmax){
				s.hhh.setFmax(s.hhhh.fmax);
			}
			else if (s.hhh.fmax>s.hhhh.fmax){
				s.hhhh.setFmax(s.hhh.fmax);
			}

	}
	if(nsamp > 9) {f.dispose();}

	}
		public void stop(){
                  if (SampleT!=null)
                  {
                    if (f!=null) f.dispose();
                    SampleT.stop();
                    SampleT=null;
                  }
		//bottom = 0;
		//h.mRect[3] = 0;
		//System.out.println("stopping");
	}
}
class MoveRect implements Runnable {
	Histogram h;
	Thread moveIt;
	MoveRect nextThread, nextThread2;
	int[] R,sp,bins,bottoms, fd2;
	int increment,xoff,g2,N,k;
	Graphics g;
	Color c;
	boolean clear;
	boolean[] stats;
	double sum;
	double ssq;
	public MoveRect(Histogram theHist, boolean[] _stats, int inc, int [] _bottoms, int[] _bins,int[] speeds, int _N, boolean _clear,Color _color, MoveRect _nextThread){
		R = new int[4];
		sp = new int[4];
		stats = new boolean[_stats.length];
		nextThread=_nextThread;
		//nextThread2=_nextThread2;
		sum=0;
		ssq=0;
		N=_N;
		for (int i=0;i<_stats.length;i++){
			stats[i]=_stats[i];
		}

		bottoms = new int[N];
		bins = new int[N];
		clear = _clear;
		h = theHist;


			c=_color;


		for (int i=0;i<N;i++){
			bottoms[i]=_bottoms[i];
			bins[i]=_bins[i];
		}
		increment = inc;
		//bottom = bot-inc-5;

		//g.setColor(Color.blue);
		g2 = h.gap/2;
		xoff = h.xoffset;


		R[2] = h.width;

		for (int i=0;i<4;i++){
			//R[i]=h.mRect[i];
			sp[i]=speeds[i];
		}

	//	bin=_bin;
	}

	public void run()
	{
	//	if (sp[2] != 0) {
		//System.out.println("N = " + N);
			h.setStats(false);
		if (clear) {
			//System.out.println("Clearing N= " + N);
			k=h.numInt;
			fd2 = new int[k];
			for (int i=0;i<k;i++){
				fd2[i]=0;
			}
			//System.out.println("h.sum " + h.sum + "h.ssq " + h.ssq);
			//System.out.println( "mr ssq= " + ssq + " sum= " + sum);
			h.setData(fd2,k,false,sum,ssq);
			h.repaint();
		}

		g = h.getGraphics();
		if (c != null) {
			g.setColor(c);
			h.setColor(c);


		}

		for (int i=0;i<N;i++){
			R[0]=xoff+R[2]*bins[i]+g2;
			//R[1]=0;
			R[1]=h.yoffset2;
			R[3]=h.yinc;

			try {Thread.sleep(sp[0]);} catch (Exception e){}
			g.fillRect(R[0],R[1],R[2],R[3]);
			try {Thread.sleep(sp[1]);} catch (Exception e){}
			while (R[1] < bottoms[i]) {
				g.clearRect(R[0],R[1],R[2],increment);
				R[1]+=increment;
				g.fillRect(R[0],R[1],R[2],R[3]);
				//System.out.println(h.mRect[1]);
				try {Thread.sleep(sp[2]);} catch (Exception e){}
			}

		//h.mRect[3] = 0;
			h.addX(bins[i]);
			//try {Thread.sleep(sp[1]);} catch (Exception e){}
			try {Thread.sleep(1);} catch (Exception e){}

		}

		h.setStats(stats);
		h.setStats(true);
		try {Thread.sleep(2);} catch (Exception e){}
		if (nextThread != null) {
				nextThread.start();
			}


	}
	public void stop(){
                if (moveIt!=null)
                {
		moveIt.stop();
		moveIt=null;
                }
		//bottom = 0;
		//h.mRect[3] = 0;
		//System.out.println("stopping");
	}
	public void start(){
		//h.mRect[3]=h.yinc;
		//System.out.println("starting");
		moveIt = new Thread(this);
		moveIt.start();
	}

	}

	class fWait extends Frame {
	Label L;
	public fWait(String title) {
		super(title);
		//setLayout (new FlowLayout());
		 L = new Label (" ");
		 L.reshape(10,30,160,50);
		add(L);
		//add(new Button("OK"));
		resize(200,100);
		show();
		//setCursor(Frame.WAIT_CURSOR);
	}
	public void setLabel(String s){
		L.setText(s);
	}
	public boolean handleEvent(Event e) {
                /*int d = e.WINDOW_DESTROY;
                System.out.println("d="+d);
		switch(e.id) {
			case 1:
				dispose();
			default:
				return false;
		}*/
                if (e.id == e.WINDOW_DESTROY)
                {
                  dispose();
                  return true;
                }
                else
                return false;
	}


}




