package districompare;
import java.awt.*;
import java.awt.Component;
import java.text.*;
import RVLS.*;

public class normDistAdj extends normDist
{
	public void paint(Graphics g) {
			Dimension dim = getSize();
			g.setColor(getBackground());
			g.fillRect(0,0,dim.width,dim.height);
			g.setColor(g.getColor());

			int adj,y;
			String num;
			y=0;
			w=getSize().width-2*XOFFSET;
			h=getSize().height-BOTTOM;
			hh=h+HADJ; //HADJ = 35 initialed in declear part
			if (setYmax==false) Ymax=MultConst;
			sp2x = range/w;
			sx2p=1/sp2x;
			sp2y= Ymax/h;
			sy2p=1/sp2y;

			g.setColor(Color.black);
			g.setFont(font);

			g.drawLine(XOFFSET,hh,XOFFSET+w,hh );
			FontMetrics met=g.getFontMetrics(font);
			int fh = met.getAscent();
			if (autoSetLimits)
				step = (upLimit-lowLimit)/numTicks; //x axis tick step
			double c = firstTick-step;
			int x;

			adj = (w - met.stringWidth(title))/2;
			g.drawString(title,XOFFSET+ adj,fh+5); //draw title
			if(yaxis) {
				double [] r = new double[3]; //r[0] is the step size
				r=graphUtilities.intlabels(0,Ymax,5);

				for (double yy=0; yy<= Ymax+r[0];yy+=r[0]){
					y = (int) Math.round(hh - sy2p*yy);  //y lable positin
					g.drawLine(XOFFSET-6,y,XOFFSET-3,y);
					num = graphUtilities.format(yy,2);
					x = XOFFSET - met.stringWidth(num) - 8;
					g.drawString(num,x,y+fh/2);          //y label string
				}
				g.drawLine(XOFFSET-2,y,XOFFSET-2,hh);
			}
		if (autoSetLimits) {//adjust the x lable decimal # according to the steps

			//System.out.println("step="+step);
			if (step >= 1.0) ndx=0;
			if (step < 1.0) ndx=1;
			if (Math.floor(sd) != sd) ndx=1;
			if (step - Math.floor(step) > 0.01) ndx=1;
			if (step < .05) ndx=2;
		}

		double tickAdj = sx2p*(firstTick-lowLimit);  //adjust the first tick position to include lowlimit
		float SL;
		num=graphUtilities.format(upLimit,ndx);
		SL = (float) met.stringWidth(num);
		double w = step*sx2p;
		int r = (int) Math.ceil(SL/(w-2));
			for (int i=0; i<= numTicks;i++){
				c+=step;
				if (i%r==0) {
				x = (int) Math.rint(XOFFSET + sx2p*i*step + tickAdj); //x label position
				 num=graphUtilities.format(c,ndx);
				g.drawLine(x,hh,x,hh+4);
				SL = (float) met.stringWidth(num);
				 adj = (int) Math.rint(SL/2);
				g.drawString(num, x-adj,hh+fh+6);  //draw x label string
			}
			}


			drawDist(g);  //draw normal distribution


	}
}