package analysis;


import RVLS.*;
import java.awt.*;
public class iScatter extends scatter  {
	scatterController sc=null;
	int currentPoint=-1;
	public void setScatterController(scatterController sc) {
		this.sc=sc;
	}
	public void setCurrentPoint(int currentPoint) {
		this.currentPoint=currentPoint;
		repaint();
	}
	public int getCurrentPoint() {
		return currentPoint;
	}
	public iScatter() {
		super();

		//{{REGISTER_LISTENERS
		SymMouse aSymMouse = new SymMouse();
		this.addMouseListener(aSymMouse);
		//}}
	}

	class SymMouse extends java.awt.event.MouseAdapter
	{
		public void mousePressed(java.awt.event.MouseEvent event)
		{
			Object object = event.getSource();
			if (object == iScatter.this)
				iScatter_mousePressed(event);
		}
	}

	void iScatter_mousePressed(java.awt.event.MouseEvent event)
	{



		double x = Lx.transformToValue(event.getX());
		double y = Ly.transformToValue(event.getY());

		if (sc!=null)
			sc.pressed(this,x,y);

	}
	public void drawPoints(Graphics g) {
		Color c1 = Color.blue;
		Color c2=Color.red;
		g.setColor(c1);
		for (int i=0;i<N;i++) {

  	 		g.fillRect(X[i]-2,Y[i]-2,4,4);

		}
		g.setColor(c2);
		if(currentPoint >=0)
			g.fillRect(X[currentPoint]-2,Y[currentPoint]-2,4,4);
	}
}
