package analysis;

import RVLS.*;
import RVLS.boxPlots;

import java.awt.*;
import java.applet.*;
import java.util.*;
import VisualNumerics.math.Statistics;
public class scatterFrame extends closeableFrame  {
	dataSet ds;
	double [] X,Y;
	String xlab, ylab;
	// int sOffSet=10;
	//final int scatterY=35;
	//final int scatterW= 375;
	//final int scatterH=350;
	public  scatterFrame(double [] X, double [] Y, String xlab, String ylab)
	{
	this.X=X;
	this.Y=Y;
	this.xlab=xlab;
	this.ylab=ylab;
		//{{INIT_CONTROLS
		setLayout(null);
		setVisible(false);
		setSize(428,482);
		//setBackground(new Color(-331));
		button1 = new java.awt.Button();
		button1.setLabel("Residual Analysis");
		button1.setBounds(218,398,145,27);
		button1.setBackground(new Color(16777215));
		add(button1);
		scatter1 = new RVLS.scatter();
		scatter1.setBounds(19,38,387,308);
		scatter1.setBackground(new Color(16777215));
		add(scatter1);
		checkbox2 = new java.awt.Checkbox("Show statistics");
		checkbox2.setBounds(27,409,162,19);
		add(checkbox2);
		checkbox1 = new java.awt.Checkbox("Show regression line");
		checkbox1.setBounds(27,383,168,19);
		add(checkbox1);
		descText2 = new RVLS.descText();
		descText2.setLayout(null);
		descText2.setVisible(false);
		descText2.setBounds(505,56,117,262);
		add(descText2);
		descText1 = new RVLS.descText();
		descText1.setLayout(null);
		descText1.setVisible(false);
		descText1.setBounds(412,56,86,262);
		add(descText1);
		label2 = new java.awt.Label("text",Label.CENTER);
		label2.setBounds(70,347,336,34);
		label2.setFont(new Font("Serif", Font.BOLD, 12));
		add(label2);
		label1 = new java.awt.Label("Y axis label");
		label1.setBounds(5,22,275,15);
		label1.setFont(new Font("Serif", Font.BOLD, 12));
		add(label1);
		//}}

		setTitle("Scatter Plot");
		//scatter1 = new RVLS.scatter();
		//add(scatter1);
		//scatter1.setBounds(sOffSet,scatterY,scatterW,scatterH);

		//double [] x1 = {1.0,3,5,2,6,8,1,3,9,2,6,8,43};
		//double [] x2 = {0.0,11,2,3,4,5,8,12,14,5,22,15,30};

		scatter1.setData(X,Y);
		//scatter1.setData(x1,x2);
		Point p1 = scatter1.getUpperLeft();
		Point p2 = scatter1.getLowerRight();
		Rectangle r = scatter1.getBounds();
		int scatterH = r.y+r.height;
		label2.setBounds(p1.x+r.x,scatterH+2,p2.x-p1.x,16);
		//label2.setBounds(p1.x,scatterY+scatterH+10,p2.x-p1.x,16);
		label2.setText(xlab);
		label1.setText(ylab);
		//label1.setVisible(false);
		//label2.setVisible(false);

			// s = {"Statistic", "N", "Mean of X", "Mean of Y", "sd of X", "sd of Y", "r", "Slope", "Intercept", "SEest"};
			double pr = scatter1.getr();
			int N2=	scatter1.getN()-2;
			//double FRp = probFandT.probF(pr*pr/((1-pr*pr)/N2),1,N2);
                        double FRp = Statistics.inverseFCdf(pr*pr/((1-pr*pr)/N2),1.0,(double)N2);

			stat = new String[11];
			stat[0] = "Value";
			stat[1] = ""+scatter1.getN();
			stat[2] = graphUtilities.format(scatter1.getXmean(),4);
			stat[3] = graphUtilities.format(scatter1.getYmean(),4);
			stat[4] = graphUtilities.format(scatter1.getSdx(),4);
			stat[5] = graphUtilities.format(scatter1.getSdy(),4);
			stat[6] = graphUtilities.format(pr,4);
			stat[7] = graphUtilities.format(scatter1.getSlope(),4);
			stat[8] = graphUtilities.format(scatter1.getIntercept(),4);
			stat[9] = graphUtilities.format(scatter1.getSampleSeEst(),4);
			stat[10] = graphUtilities.format(FRp,4);

	//System.out.println("A");
			//descText1.setData(s);

			//descText2.setData(stat);


		//{{REGISTER_LISTENERS

		SymAction lSymAction = new SymAction();
		SymItem lSymItem = new SymItem();
		checkbox1.addItemListener(lSymItem);
		checkbox2.addItemListener(lSymItem);
		button1.addActionListener(lSymAction);
		//}}

		//{{INIT_MENUS
		//}}
}



	//{{DECLARE_CONTROLS
	java.awt.Button button1;
	RVLS.scatter scatter1;
	java.awt.Checkbox checkbox2;
	java.awt.Checkbox checkbox1;
	RVLS.descText descText2;
	RVLS.descText descText1;
	java.awt.Label label2;
	java.awt.Label label1;
	//}}


	String [] stat;
	String [] s;



	//{{DECLARE_MENUS
	//}}


	class SymAction implements java.awt.event.ActionListener
	{
		public void actionPerformed(java.awt.event.ActionEvent event)
		{
			Object object = event.getSource();
			if (object == button1)
				button1_ActionPerformed(event);
		}
	}



	class SymItem implements java.awt.event.ItemListener
	{
		public void itemStateChanged(java.awt.event.ItemEvent event)
		{
			Object object = event.getSource();
			if (object == checkbox1)
				checkbox1_ItemStateChanged(event);
			else if (object == checkbox2)
				checkbox2_ItemStateChanged(event);
		}
	}

	void checkbox1_ItemStateChanged(java.awt.event.ItemEvent event)
	{
		scatter1.setRegLine(checkbox1.getState());
	}

	void checkbox2_ItemStateChanged(java.awt.event.ItemEvent event)
	{

		if(checkbox2.getState()) {
			setSize(632,464);

			String [] s = {"Statistic", "N", "Mean of X", "Mean of Y", "sd of X", "sd of Y", "r", "Slope", "Intercept", "SEest", "p"};
			/*
			String [] stat = new String[10];
			stat[0] = "Value";
			stat[1] = ""+scatter1.getN();
			stat[2] = graphUtilities.format(scatter1.getXmean(),4);
			stat[3] = graphUtilities.format(scatter1.getYmean(),4);
			stat[4] = graphUtilities.format(scatter1.getSdx(),4);
			stat[5] = graphUtilities.format(scatter1.getSdy(),4);
			stat[6] = graphUtilities.format(scatter1.getr(),4);
			stat[7] = graphUtilities.format(scatter1.getSlope(),4);
			stat[8] = graphUtilities.format(scatter1.getIntercept(),4);
			stat[9] = graphUtilities.format(scatter1.getSampleSeEst(),4);
*/
			descText1.setData(s);
			descText2.setData(stat);
			descText1.setVisible(true);
			descText2.setVisible(true);
		}
		else {
			descText1.setVisible(false);
			descText2.setVisible(false);
			setSize(425,464);
		}

	}




	void button1_ActionPerformed(java.awt.event.ActionEvent event)
	{
		//double [] yp = new double[Y.length];
		//double [] R = new double[Y.length];
		double b = scatter1.getSlope();

		double A = scatter1.getIntercept();
		/*
		for (int i=0;i<Y.length;i++) {
			yp[i]=b*X[i] + A;
			R[i] = Y[i]-yp[i];
		}
		*/
		residFrame rf = new residFrame(X,Y,b,A,xlab,ylab);
		rf.show();
	}
}
