package analysis;

import java.awt.*;
import RVLS.*;
import VisualNumerics.math.Statistics;
public class anovaFrame extends closeableFrame {
	String name = "Groups";
	public void setName(String name) {
		this.name = name;
	}
	public anovaFrame() {
			//{{INIT_CONTROLS
		setLayout(null);
		setVisible(false);
		setSize(677,188);
		labelp = new java.awt.Label("",Label.RIGHT);
		labelp.setBounds(524,66,78,18);
		labelp.setFont(new Font("Monospaced", Font.PLAIN, 12));
		add(labelp);
		sst = new java.awt.Label("",Label.RIGHT);
		sst.setBounds(208,121,90,19);
		sst.setFont(new Font("Monospaced", Font.PLAIN, 12));
		add(sst);
		dft = new java.awt.Label("",Label.RIGHT);
		dft.setBounds(145,119,46,24);
		dft.setFont(new Font("Monospaced", Font.PLAIN, 12));
		add(dft);
		label8 = new java.awt.Label("Total");
		label8.setBounds(32,118,103,24);
		label8.setFont(new Font("Monospaced", Font.PLAIN, 12));
		add(label8);
		mse = new java.awt.Label("",Label.RIGHT);
		mse.setBounds(312,92,100,20);
		mse.setFont(new Font("Monospaced", Font.PLAIN, 12));
		add(mse);
		sse = new java.awt.Label("",Label.RIGHT);
		sse.setBounds(208,91,90,19);
		sse.setFont(new Font("Monospaced", Font.PLAIN, 12));
		add(sse);
		dfe = new java.awt.Label("",Label.RIGHT);
		dfe.setBounds(145,90,46,24);
		dfe.setFont(new Font("Monospaced", Font.PLAIN, 12));
		add(dfe);
		label7 = new java.awt.Label("Error");
		label7.setBounds(34,89,103,24);
		label7.setFont(new Font("Monospaced", Font.PLAIN, 12));
		add(label7);
		f = new java.awt.Label("",Label.RIGHT);
		f.setBounds(433,66,78,18);
		f.setFont(new Font("Monospaced", Font.PLAIN, 12));
		add(f);
		msbet = new java.awt.Label("",Label.RIGHT);
		msbet.setBounds(312,66,100,20);
		msbet.setFont(new Font("Monospaced", Font.PLAIN, 12));
		add(msbet);
		ssbet = new java.awt.Label("",Label.RIGHT);
		ssbet.setBounds(208,65,90,19);
		ssbet.setFont(new Font("Monospaced", Font.PLAIN, 12));
		add(ssbet);
		df = new java.awt.Label("",Label.RIGHT);
		df.setBounds(145,65,46,24);
		df.setFont(new Font("Monospaced", Font.PLAIN, 12));
		add(df);
		groups = new java.awt.Label("");
		groups.setBounds(32,65,103,24);
		groups.setFont(new Font("Monospaced", Font.PLAIN, 12));
		add(groups);
		label6 = new java.awt.Label("p",Label.CENTER);
		label6.setBounds(528,38,92,28);
		label6.setFont(new Font("Monospaced", Font.BOLD, 12));
		label6.setBackground(new Color(12632256));
		add(label6);
		label5 = new java.awt.Label("F",Label.CENTER);
		label5.setBounds(426,38,92,28);
		label5.setFont(new Font("Monospaced", Font.BOLD, 12));
		label5.setBackground(new Color(12632256));
		add(label5);
		label4 = new java.awt.Label("MS",Label.CENTER);
		label4.setBounds(312,38,108,28);
		label4.setFont(new Font("Monospaced", Font.BOLD, 12));
		label4.setBackground(new Color(12632256));
		add(label4);
		label3 = new java.awt.Label("SSQ",Label.CENTER);
		label3.setBounds(204,37,101,26);
		label3.setFont(new Font("Monospaced", Font.BOLD, 12));
		label3.setBackground(new Color(12632256));
		add(label3);
		label2 = new java.awt.Label("df",Label.CENTER);
		label2.setBounds(143,37,54,27);
		label2.setFont(new Font("Monospaced", Font.BOLD, 12));
		label2.setBackground(new Color(12632256));
		add(label2);
		label1 = new java.awt.Label("Source",Label.CENTER);
		label1.setBounds(22,37,116,28);
		label1.setFont(new Font("Monospaced", Font.BOLD, 12));
		label1.setBackground(new Color(12632256));
		add(label1);
		//}}
		//{{INIT_MENUS
		//}}
		setTitle ("ANOVA");
}
	//public void setData(double [][] x, int [] N, int k) {
	public void setData(double [][] x) {
		anova an = new anova();
		an.setData(x);
		int df1=an.getDfn();
		int df2 = an.getDfd();
		int dftot=df1+df2;
		df.setText(df1 + "");
		groups.setText(name);
		ssbet.setText(graphUtilities.format(an.getSsb(),4));
		msbet.setText(graphUtilities.format(an.getMsb(),4));
		f.setText(graphUtilities.format(an.getF(),4));
		dfe.setText(df2 + "");
		mse.setText(graphUtilities.format(an.getMse(),4));
		sse.setText(graphUtilities.format(an.getSse(),4));
		dft.setText(dftot+"");
		sst.setText(graphUtilities.format(an.getSst(),4));
		double p = 1.0-Statistics.FCdf(an.getF(),df1,df2);
                if (p<=0.05) labelp.setForeground(Color.red);
		labelp.setText(graphUtilities.format(p,4));

	}
	//{{DECLARE_CONTROLS
	java.awt.Label labelp;
	java.awt.Label sst;
	java.awt.Label dft;
	java.awt.Label label8;
	java.awt.Label mse;
	java.awt.Label sse;
	java.awt.Label dfe;
	java.awt.Label label7;
	java.awt.Label f;
	java.awt.Label msbet;
	java.awt.Label ssbet;
	java.awt.Label df;
	java.awt.Label groups;
	java.awt.Label label6;
	java.awt.Label label5;
	java.awt.Label label4;
	java.awt.Label label3;
	java.awt.Label label2;
	java.awt.Label label1;
	//}}
	//{{DECLARE_MENUS
	//}}
}