package analysis;

import java.awt.*;
import RVLS.*;
import VisualNumerics.math.Statistics;
public class repeatanovaFrame extends closeableFrame {

        public repeatanovaFrame (){
                        //{{INIT_CONTROLS
                setLayout(null);
                setVisible(false);
                setSize(677,188);

                sst = new java.awt.Label("",Label.RIGHT);
                sst.setBounds(208,125,90,19);
                sst.setFont(new Font("Monospaced", Font.PLAIN, 12));
                add(sst);
                dft = new java.awt.Label("",Label.RIGHT);
                dft.setBounds(145,125,46,24);
                dft.setFont(new Font("Monospaced", Font.PLAIN, 12));
                add(dft);
                label8 = new java.awt.Label("Total");
                label8.setBounds(32,125,103,24);
                label8.setFont(new Font("Monospaced", Font.PLAIN, 12));
                add(label8);


                mse = new java.awt.Label("",Label.RIGHT);
                mse.setBounds(312,105,100,20);
                mse.setFont(new Font("Monospaced", Font.PLAIN, 12));
                add(mse);
                sse = new java.awt.Label("",Label.RIGHT);
                sse.setBounds(208,105,90,20);
                sse.setFont(new Font("Monospaced", Font.PLAIN, 12));
                add(sse);
                dfe = new java.awt.Label("",Label.RIGHT);
                dfe.setBounds(145,105,46,20);
                dfe.setFont(new Font("Monospaced", Font.PLAIN, 12));
                add(dfe);
                label7 = new java.awt.Label("Error");
                label7.setBounds(34,105,103,20);
                label7.setFont(new Font("Monospaced", Font.PLAIN, 12));
                add(label7);

                labelp = new java.awt.Label("",Label.RIGHT);
                labelp.setBounds(524,85,78,18);
                labelp.setFont(new Font("Monospaced", Font.PLAIN, 12));
                add(labelp);
                f = new java.awt.Label("",Label.RIGHT);
                f.setBounds(433,85,78,20);
                f.setFont(new Font("Monospaced", Font.PLAIN, 12));
                add(f);
                msbet = new java.awt.Label("",Label.RIGHT);
                msbet.setBounds(312,85,100,20);
                msbet.setFont(new Font("Monospaced", Font.PLAIN, 12));
                add(msbet);
                ssbet = new java.awt.Label("",Label.RIGHT);
                ssbet.setBounds(208,85,90,20);
                ssbet.setFont(new Font("Monospaced", Font.PLAIN, 12));
                add(ssbet);
                df = new java.awt.Label("",Label.RIGHT);
                df.setBounds(145,85,46,20);
                df.setFont(new Font("Monospaced", Font.PLAIN, 12));
                add(df);
                groups = new java.awt.Label("");
                groups.setBounds(32,85,103,20);
                groups.setFont(new Font("Monospaced", Font.PLAIN, 12));
                add(groups);

                msret = new java.awt.Label("",Label.RIGHT);
                msret.setBounds(312,65,100,20);
                msret.setFont(new Font("Monospaced", Font.PLAIN, 12));
                add(msret);
                ssret = new java.awt.Label("",Label.RIGHT);
                ssret.setBounds(208,65,90,20);
                ssret.setFont(new Font("Monospaced", Font.PLAIN, 12));
                add(ssret);
                dfr = new java.awt.Label("",Label.RIGHT);
                dfr.setBounds(145,65,46,20);
                dfr.setFont(new Font("Monospaced", Font.PLAIN, 12));
                add(dfr);
                groupr = new java.awt.Label("");
                groupr.setBounds(32,65,103,20);
                groupr.setFont(new Font("Monospaced", Font.PLAIN, 12));
                add(groupr);

                label6 = new java.awt.Label("p",Label.CENTER);
                label6.setBounds(528,38,92,27);
                label6.setFont(new Font("Monospaced", Font.BOLD, 12));
                label6.setBackground(new Color(12632256));
                add(label6);
                label5 = new java.awt.Label("F",Label.CENTER);
                label5.setBounds(426,38,92,27);
                label5.setFont(new Font("Monospaced", Font.BOLD, 12));
                label5.setBackground(new Color(12632256));
                add(label5);
                label4 = new java.awt.Label("MS",Label.CENTER);
                label4.setBounds(312,38,108,27);
                label4.setFont(new Font("Monospaced", Font.BOLD, 12));
                label4.setBackground(new Color(12632256));
                add(label4);
                label3 = new java.awt.Label("SSQ",Label.CENTER);
                label3.setBounds(204,38,101,27);
                label3.setFont(new Font("Monospaced", Font.BOLD, 12));
                label3.setBackground(new Color(12632256));
                add(label3);
                label2 = new java.awt.Label("df",Label.CENTER);
                label2.setBounds(143,38,54,27);
                label2.setFont(new Font("Monospaced", Font.BOLD, 12));
                label2.setBackground(new Color(12632256));
                add(label2);
                label1 = new java.awt.Label("Source",Label.CENTER);
                label1.setBounds(22,38,116,27);
                label1.setFont(new Font("Monospaced", Font.BOLD, 12));
                label1.setBackground(new Color(12632256));
                add(label1);
                //}}
                //{{INIT_MENUS
                //}}
                setTitle ("Repeated-Measures ANOVA");
}
        //public void setData(double [][] x, int [] N, int k) {
public void setData(String group, String repeat, double [][] x) {
  repeatanova a = new repeatanova();
  a.setData(x);
  groups.setText(group);
  groupr.setText(repeat);

  dfr.setText(""+a.dfsubject);
  df.setText(""+a.dftrial);
  dfe.setText(""+a.dferror);
  dft.setText(""+a.dftotal);

  ssret.setText(Utility.format(a.sssubject,4));
  ssbet.setText(Utility.format(a.sstrial,4));
  sse.setText(Utility.format(a.sserror,4));
  sst.setText(Utility.format(a.sstotal,4));

  msret.setText(Utility.format(a.mssubject,4));
  msbet.setText(Utility.format(a.mstrial,4));
  mse.setText(Utility.format(a.mse,4));

  if (a.Ftrial>0)
  {
    f.setText(Utility.format(a.Ftrial,4));
    if (a.ptrial<=0.05)
     labelp.setForeground(Color.red);
    labelp.setText(Utility.format(a.ptrial,4));
  }
  else
  {
    f.setText("N/A");
    labelp.setText("N/A");
  }
}

        //{{DECLARE_CONTROLS
        java.awt.Label labelp;
        java.awt.Label sst;
        java.awt.Label dft;
        java.awt.Label label8;
        java.awt.Label mse;
        java.awt.Label sse;
        java.awt.Label dfe;
        java.awt.Label label7;
        java.awt.Label f;
        java.awt.Label msbet;
        java.awt.Label ssbet;
        java.awt.Label df;
        java.awt.Label groups;
        java.awt.Label msret;
        java.awt.Label ssret;
        java.awt.Label dfr;
        java.awt.Label groupr;
        java.awt.Label label6;
        java.awt.Label label5;
        java.awt.Label label4;
        java.awt.Label label3;
        java.awt.Label label2;
        java.awt.Label label1;
        //}}
        //{{DECLARE_MENUS
        //}}
}