package binomialrvls;

import java.util.*;
import RVLS.*;
import java.awt.*;
import java.applet.*;
import VisualNumerics.math.Statistics;

public class binomialFrame extends closeableFrame
{

	public  binomialFrame()
	{
		setTitle("Normal Approximation to Binomial Demo");
		//{{INIT_CONTROLS
		setLayout(null);
		setVisible(false);
		setSize(554,300);
		setBackground(new Color(0));
		panel2 = new java.awt.Panel();
		panel2.setLayout(null);
		panel2.setBounds(15,17,204,63);
		panel2.setBackground(new Color(-393270));
		add(panel2);
		button1 = new java.awt.Button();
		button1.setLabel("enter");
		button1.setBounds(136,22,56,17);
		panel2.add(button1);
		textFieldN = new java.awt.TextField();
		textFieldN.setText("8");
		textFieldN.setBounds(22,22,42,21);
		panel2.add(textFieldN);
		textFieldp = new java.awt.TextField();
		textFieldp.setText(".5");
		textFieldp.setBounds(84,22,42,21);
		panel2.add(textFieldp);
		labelp = new java.awt.Label("p",Label.CENTER);
		labelp.setBounds(79,1,45,22);
		panel2.add(labelp);
		labelN = new java.awt.Label("N",Label.CENTER);
		labelN.setBounds(21,1,45,22);
		panel2.add(labelN);
		panel1 = new java.awt.Panel();
		panel1.setLayout(null);
		panel1.setBounds(15,86,204,194);
		panel1.setBackground(new Color(-393270));
		add(panel1);
		label8 = new java.awt.Label("Approximation",Label.CENTER);
		label8.setBounds(103,141,97,14);
		panel1.add(label8);
		label9 = new java.awt.Label("Binomial",Label.CENTER);
		label9.setBounds(13,126,78,14);
		panel1.add(label9);
		label7 = new java.awt.Label("Probability",Label.CENTER);
		label7.setBounds(13,141,78,14);
		panel1.add(label7);
		label6 = new java.awt.Label("Normal",Label.CENTER);
		label6.setBounds(112,126,78,14);
		panel1.add(label6);
		label5 = new java.awt.Label("to:",Label.RIGHT);
		label5.setBounds(43,54,62,22);
		panel1.add(label5);
		label4 = new java.awt.Label("of from:",Label.RIGHT);
		label4.setBounds(43,25,62,22);
		panel1.add(label4);
		label3 = new java.awt.Label("successes (inclusive).");
		label3.setBounds(38,78,143,19);
		panel1.add(label3);
		zapprox = new java.awt.Label("", Label.CENTER);
		zapprox.setBounds(122,158,58,20);
		panel1.add(zapprox);
		LL = new java.awt.TextField();
		LL.setText("3");
		LL.setBounds(113,27,45,19);
		panel1.add(LL);
		UL = new java.awt.TextField();
		UL.setText("5");
		UL.setBounds(113,56,45,19);
		panel1.add(UL);
		checkbox1 = new java.awt.Checkbox("Show probability");
		checkbox1.setBounds(37,0,151,24);
		panel1.add(checkbox1);
		checkbox1.setState(true);
		cumP = new java.awt.Label("",Label.CENTER);
		cumP.setBounds(23,158,58,20);
		panel1.add(cumP);
		normalApprox1 = new normalApprox();
		normalApprox1.setUpCutoff(5.5);
		normalApprox1.setFillColor(new java.awt.Color(16711680));
		normalApprox1.setLowCutoff(2.5);
		normalApprox1.setTitle("Normal Approximation, N=8, p=0.5");
		normalApprox1.setShade(true);
		normalApprox1.setBounds(231,17,311,263);
		normalApprox1.setBackground(new Color(-393270));
		add(normalApprox1);
		panel3 = new java.awt.Panel();
		panel3.setLayout(null);
		panel3.setVisible(false);
		panel3.setBounds(231,17,311,263);
		panel3.setBackground(new Color(-393270));
		add(panel3);
		eMessage = new java.awt.Label("Please enter the N and p correctly.",Label.CENTER);
		eMessage.setBounds(21,100,250,20);
		panel3.add(eMessage);
		//}}
		double bp = normalApprox1.B(3, 5);
		cumP.setText(graphUtilities.format(bp,4));

		double LZ = (3.0-0.5 - 4)/Math.sqrt(2.0);
		double UZ = (5.0+0.5 - 4)/Math.sqrt(2.0);
		double lowProb = zdist.zprob(LZ);
		double upProb = zdist.zprob(UZ);
		double approxCum = upProb - lowProb;
		zapprox.setText(graphUtilities.format(approxCum,4));

                alert1=new alert();

		//{{REGISTER_LISTENERS
		SymAction lSymAction = new SymAction();
		textFieldN.addActionListener(lSymAction);
		textFieldp.addActionListener(lSymAction);
		SymFocus aSymFocus = new SymFocus();
		textFieldN.addFocusListener(aSymFocus);
		textFieldp.addFocusListener(aSymFocus);
		SymItem lSymItem = new SymItem();
		checkbox1.addItemListener(lSymItem);
		LL.addActionListener(lSymAction);
		UL.addActionListener(lSymAction);
		//buttonOK.addFocusListener(aSymFocus);
		LL.addFocusListener(aSymFocus);
		UL.addFocusListener(aSymFocus);

		button1.addActionListener(lSymAction);
		SymText lSymText = new SymText();
		textFieldp.addTextListener(lSymText);
		//}}
		//normalApprox1.setShadedArea(6.5,8.5);
		//normalApprox1.setShade(true);
		textFieldN.requestFocus();
		//textFieldN.selectAll();
		//setShades();

			//{{INIT_MENUS
		//}}
}
	alert alert1=null;
	//{{DECLARE_CONTROLS
	java.awt.Panel panel2;
	java.awt.Button button1;
	java.awt.TextField textFieldN;
	java.awt.TextField textFieldp;
	java.awt.Label labelp;
	java.awt.Label labelN;
	java.awt.Panel panel1;
	java.awt.Label label8;
	java.awt.Label label9;
	java.awt.Label label7;
	java.awt.Label label6;
	java.awt.Label label5;
	java.awt.Label label4;
	java.awt.Label label3;
	java.awt.Label zapprox;
	java.awt.TextField LL;
	java.awt.TextField UL;
	java.awt.Checkbox checkbox1;
	java.awt.Label cumP;
	normalApprox normalApprox1;
	java.awt.Panel panel3;
	java.awt.Label eMessage;
	//}}
	boolean errN=false, errP=false;

	void upDateN()
	{
		try {
				int n=  Integer.valueOf(textFieldN.getText().trim()).intValue();
				if (n<=0) {
					alert1.setMessage("n must be greater than 0.");
					alert1.show();
					normalApprox1.setVisible(false);
					panel3.setVisible(true);
					errN = true;
				}
				else
				{
					errN=false;
					normalApprox1.setN(n);
					normalApprox1.setTitle("Normal Approximation, N="+normalApprox1.getN()+", p="+normalApprox1.getP());
					if (errP == false)
					{
						 panel3.setVisible(false);
						 normalApprox1.setVisible(true);
						 repaint();
					}
				}
			}
			catch (NumberFormatException e) {
				alert1.setMessage("n must be an integer.");
				alert1.show();
			}
	}

	void upDatep()
	{
		try {
				double p=  Double.valueOf(textFieldp.getText().trim()).doubleValue();
				if ( (p<0) || (p>1) || (Math.abs(p)<0.00001) || (Math.abs(p-1.0)<0.00001) )
				{
					alert1.setMessage("p must be a number between 0 and 1.");
					alert1.show();
					normalApprox1.setVisible(false);
					panel3.setVisible(true);
					errP = true;
				}
				else
				{
					errP = false;
					normalApprox1.setP(p);
					normalApprox1.setTitle("Normal Approximation, N="+normalApprox1.getN()+", p="+normalApprox1.getP());
					if (errN == false)
					{
						panel3.setVisible(false);
						normalApprox1.setVisible(true);
						repaint();
					}
				}
			}
			catch (NumberFormatException e) {
				alert1.setMessage("p must be a number between 0 and 1.");
				alert1.show();
			}
	}

	class SymAction implements java.awt.event.ActionListener
	{
		public void actionPerformed(java.awt.event.ActionEvent event)
		{
			Object object = event.getSource();
			if (object == textFieldN)
				textFieldN_EnterHit(event);
			else if (object == textFieldp)
				textFieldp_EnterHit(event);
			if (object == LL)
				LL_EnterHit(event);
			else if (object == UL)
				UL_EnterHit(event);
			else if (object == button1)
				button1_ActionPerformed(event);
		}
	}

	void textFieldN_EnterHit(java.awt.event.ActionEvent event)
	{
		upDateN();
		if((checkbox1.getState()) && (errP=false) && (errN=false))
		setShades();

		textFieldN.selectAll();
	}



	void textFieldp_EnterHit(java.awt.event.ActionEvent event)
	{
		upDatep();
		if((checkbox1.getState()) && (errP==false) && (errN==false))
		setShades();

		textFieldp.selectAll();
	}



	class SymFocus extends java.awt.event.FocusAdapter
	{
		public void focusLost(java.awt.event.FocusEvent event)
		{
			Object object = event.getSource();
			if (object == textFieldN)
				textFieldN_FocusLost(event);
			else if (object == textFieldp)
				textFieldp_FocusLost(event);
			else if (object == LL)
				LL_FocusLost(event);
			else if (object == UL)
				UL_FocusLost(event);
		}

		public void focusGained(java.awt.event.FocusEvent event)
		{
			Object object = event.getSource();
			if (object == textFieldN)
				textFieldN_FocusGained(event);
			else if (object == textFieldp)
				textFieldp_FocusGained(event);
			else if (object == LL)
				LL_FocusGained(event);
			else if (object == UL)
				UL_FocusGained(event);
		}
	}

	void textFieldN_FocusGained(java.awt.event.FocusEvent event)
	{
		textFieldN.selectAll();
	}

	void textFieldN_FocusLost(java.awt.event.FocusEvent event)
	{
		textFieldN.select(0,0);
		upDateN();
		if ((checkbox1.getState()) && (errP==false) && (errN==false))
		setShades();
	}

	void textFieldp_FocusGained(java.awt.event.FocusEvent event)
	{
		textFieldp.selectAll();
	}

	void textFieldp_FocusLost(java.awt.event.FocusEvent event)
	{
		textFieldp.select(0,0);
		upDatep();
		if ((checkbox1.getState()) && (errP==false) && (errN==false))
		setShades();
	}

	class SymItem implements java.awt.event.ItemListener
	{
		public void itemStateChanged(java.awt.event.ItemEvent event)
		{
			Object object = event.getSource();
			if (object == checkbox1)
				checkbox1_ItemStateChanged(event);
		}
	}

	void checkbox1_ItemStateChanged(java.awt.event.ItemEvent event)
	{
		//boolean show = checkbox1.getState();
		if (event.getStateChange() == java.awt.event.ItemEvent.SELECTED) {

			normalApprox1.setShade(true);
			if ((errP==false) && (errN==false)) setShades();
		}
		else {
			normalApprox1.setShade(false);
			zapprox.setText("");
			cumP.setText("");
			if ((errP==false) && (errN==false)) normalApprox1.repaint();
		}
		//repaint();
	}
	void setShades() {
		try {
				int LP =  Integer.valueOf(LL.getText().trim()).intValue();
				int UP=  Integer.valueOf(UL.getText().trim()).intValue();
				if (UP < LP) {
					int tp = UP;
					UP=LP;
					LP=tp;
				}

                                LP = Math.max(0,LP);
                                UP = Math.min(UP, normalApprox1.getN());
                                double bp = normalApprox1.B(LP, UP);
                                cumP.setText(graphUtilities.format(bp,4));

                                double LPd = (double)LP-0.5;
                                double UPd = (double)UP+0.5;
                                if (UP >= normalApprox1.getN())
                                {
                                  UPd = normalApprox1.getHp()+3.0*normalApprox1.getSd();
                                }

				if (LP <=0)
                                {
                                  LPd = normalApprox1.getLp()-3.0*normalApprox1.getSd();;
                                }

				normalApprox1.setShadedArea(LPd,UPd);
                                //System.out.println("LPd="+LPd+", UPd="+UPd);

                                double sd = normalApprox1.getSd();
                                double mean = normalApprox1.getMean();
                                double approxCum = -Statistics.normalCdf((LPd-mean)/sd)+Statistics.normalCdf((UPd-mean)/sd);
                                zapprox.setText(graphUtilities.format(approxCum,4));


				normalApprox1.repaint();

		}
			catch (NumberFormatException e) {
					alert1.setMessage("\"From\" and \"to\" values must be integers.");
					alert1.show();
			}

	}

	void LL_EnterHit(java.awt.event.ActionEvent event)
	{
		LL.selectAll();
		if ((checkbox1.getState()) && (errP==false) && (errN==false))
		setShades();
	}

	void UL_EnterHit(java.awt.event.ActionEvent event)
	{
		UL.selectAll();
		if ((checkbox1.getState()) && (errP==false) && (errN==false))
		setShades();
	}



	void LL_FocusGained(java.awt.event.FocusEvent event)
	{
		LL.selectAll();
	}

	void UL_FocusGained(java.awt.event.FocusEvent event)
	{
		UL.selectAll();
	}

	void LL_FocusLost(java.awt.event.FocusEvent event)
	{
		LL.select(0,0);
		if ((checkbox1.getState()) && (errP==false) && (errN==false))
		setShades();
	}

	void UL_FocusLost(java.awt.event.FocusEvent event)
	{
		UL.select(0,0);
		if ((checkbox1.getState()) && (errP==false) && (errN==false))
		setShades();
	}





	//{{DECLARE_MENUS
	//}}


	void button1_ActionPerformed(java.awt.event.ActionEvent event)
	{
		upDatep();
		upDateN();
		if((checkbox1.getState()) && (errP==false) && (errN==false))
		setShades();
	}

	class SymText implements java.awt.event.TextListener
	{
		public void textValueChanged(java.awt.event.TextEvent event)
		{
			Object object = event.getSource();
			if (object == textFieldp)
				textFieldp_TextValueChanged(event);
		}
	}

	void textFieldp_TextValueChanged(java.awt.event.TextEvent event)
	{
		// to do: code goes here.
	}
}


