package hist;

import RVLS.*;
import symantec.itools.awt.WrappingLabel;
import java.awt.*;
import java.applet.*;

public class iHistFrame extends closeableFrame  implements scatterController{
		double [] hHfact = new double[30];  //30 bin widths, calculated from h and hfact in rawHist
	    double [] cvalue = new double[30];  //30 crossValidation correspondents to 30 bins
	    double [] cvalueA = new double[20]; //20 crossValidation correspondents to 20 starting position
	    double [] hBfact = new double[20]; //20 fisrt bin positions
	    final int hBMax=19;  //max # of bin starting position
	    final int hHMax=29;  //max # of bin width
	    final int rightMargin = 75;
	    int inH=0;
	    int inA=0;
	    int nEmpty=0;
	    int currWidth=0;
	    double minCvalue=999999999;
		double maxCvalue=-999999999;
		iScatter iScatter1, iScatter2;
	/**
	 * class constructor
	 */
	public iHistFrame (double [] x){

			//{{INIT_CONTROLS
		setLayout(null);
		setVisible(false);
		setSize(600,510);
		setBackground(new Color(-52));
		button1 = new java.awt.Button();
		button1.setLabel("OK");
		button1.setBounds(16,422,40,28);
		//button1.setBackground(new Color(16777215));
		add(button1);
		textFieldH = new java.awt.TextField();
		textFieldH.setBounds(62,423,59,26);
		textFieldH.setFont(new Font("Serif", Font.PLAIN, 12));
		add(textFieldH);
		buttonDecH = new java.awt.Button();
		buttonDecH.setLabel("-");
		buttonDecH.setBounds(130,427,25,19);
		//buttonDecH.setBackground(new Color(16777215));
		add(buttonDecH);
		buttonIncH = new java.awt.Button();
		buttonIncH.setLabel("+");
		buttonIncH.setBounds(160,427,25,19);
		//buttonIncH.setBackground(new Color(16777215));
		add(buttonIncH);
		buttonDecA = new java.awt.Button();
		buttonDecA.setLabel("-");
		buttonDecA.setBounds(413,427,25,19);
		//buttonDecA.setBackground(new Color(16777215));
		add(buttonDecA);
		buttonDecA.setEnabled(false);
		buttonIncA = new java.awt.Button();
		buttonIncA.setLabel("+");
		buttonIncA.setBounds(442,427,25,19);
		//buttonIncA.setBackground(new Color(16777215));
		add(buttonIncA);
		textFieldA0 = new java.awt.TextField();
		textFieldA0.setBounds(477,423,59,26);
		textFieldA0.setFont(new Font("Serif", Font.PLAIN, 12));
		add(textFieldA0);
		button2 = new java.awt.Button();
		button2.setLabel("OK");
		button2.setBounds(554,421,40,28);
		//button2.setBackground(new Color(16777215));
		add(button2);
		wrappingLabel1 = new symantec.itools.awt.WrappingLabel();
		try {
			wrappingLabel1.setText("Click on the +/- buttons, on a graph, or enter a value in a field to change a value.");
		}
		catch(java.beans.PropertyVetoException e) { }
		wrappingLabel1.setBounds(247,415,141,53);
		wrappingLabel1.setFont(new Font("Serif", Font.PLAIN, 12));
		add(wrappingLabel1);
		label4 = new java.awt.Label("Cross Validation (lower is better)");
		label4.setBounds(323,215,177,13);
		label4.setFont(new Font("Serif", Font.PLAIN, 12));
		add(label4);
		label3 = new java.awt.Label("Cross Validation (lower is better)");
		label3.setBounds(20,215,177,13);
		label3.setFont(new Font("Serif", Font.PLAIN, 12));
		add(label3);
		label2 = new java.awt.Label("Lower Limit of First Bin");
		label2.setBounds(410,408,150,13);
		label2.setFont(new Font("Serif", Font.BOLD, 12));
		add(label2);
		label1 = new java.awt.Label("Bin Width");
		label1.setBounds(131,406,100,15);
		label1.setFont(new Font("Serif", Font.BOLD, 12));
		add(label1);
		rawHist1 = new rawHist();
		rawHist1.setBounds(14,31,550,170);
		rawHist1.setBackground(new Color(16777215));
		add(rawHist1);
		//}}
		setTitle ("Histogram");
		setBackground(new Color(16777215));
		 iScatter1=new iScatter();
		 iScatter2=new iScatter();

		iScatter1.setBounds(15,218,281,181);
		iScatter1.setBackground(new Color(16777215));
		add(iScatter1);

		iScatter2.setBounds(315,218,281,181);
		iScatter2.setBackground(new Color(16777215));
		add(iScatter2);
		//setBackground(parameters.getBackGroundColor());
		Sort.sort(x);
		rawHist1.setData(x);

		rawHist1.setColor(Color.blue);
		rawHist1.setRightMargin(rightMargin);
		iScatter1.setScatterController(this);
		iScatter2.setScatterController(this);
		upDateLabels();
		cvH(true); //define hHfact and cvalue and plot cvalue as a function of hHfact

		int in = 0;
		double cvalueMin;

		//find best h
		cvalueMin = cvalue[0];
		for(int i=1;i<30;i++) {
			if (cvalue[i] < cvalueMin) {
				cvalueMin = cvalue[i];
				in =i;
			}
		}
		inA=0;
		inH=in;

		upDateH(); //set red dot on iScatter1, do cv for a0 and redefine hBfact
		//rawHist1.clearOffset();

		/* --
		// set the h
		rawHist1.setH(hHfact[in]);

		cvH(true); // compute new hHfact and cvalues


		//find minimum
		cvalueMin = cvalue[0];
		for(int i=1;i<30;i++) {
			if (cvalue[i] < cvalueMin) {
				cvalueMin = cvalue[i];
				in =i;
			}
			maxCvalue = Math.max(maxCvalue,cvalue[i]);
			minCvalue=cvalueMin;

		}



		//iScatter1.setCurrentPoint(in);

		inH=in;
		cvH(false);
			upDateH();
		cvB(true);
		upDateA();
		*/
			double d = .02*(maxCvalue-minCvalue);
	   		minCvalue -= d;
	    	maxCvalue +=d;
		iScatter2.setData(hBfact,cvalueA,hBfact[0],hBfact[hBMax],minCvalue,maxCvalue); //set scatter for bin width vs. cv
		iScatter2.setCurrentPoint(0);
		iScatter1.ndecy=4;
		iScatter2.ndecy=4;
		textFieldA0.setText(graphUtilities.format(rawHist1.a0,4));
		textFieldH.setText(graphUtilities.format(rawHist1.h,4));
		showCV();
		//{{REGISTER_LISTENERS
		SymAction lSymAction = new SymAction();
		buttonDecH.addActionListener(lSymAction);
		buttonIncH.addActionListener(lSymAction);
		buttonDecA.addActionListener(lSymAction);
		buttonIncA.addActionListener(lSymAction);
		textFieldA0.addActionListener(lSymAction);
		textFieldH.addActionListener(lSymAction);
		button1.addActionListener(lSymAction);
		button2.addActionListener(lSymAction);
		SymFocus aSymFocus = new SymFocus();
		textFieldH.addFocusListener(aSymFocus);
		textFieldA0.addFocusListener(aSymFocus);
		//}}
			//{{INIT_MENUS
		//}}
}
	//{{DECLARE_CONTROLS
	java.awt.Button button1;
	java.awt.TextField textFieldH;
	java.awt.Button buttonDecH;
	java.awt.Button buttonIncH;
	java.awt.Button buttonDecA;
	java.awt.Button buttonIncA;
	java.awt.TextField textFieldA0;
	java.awt.Button button2;
	symantec.itools.awt.WrappingLabel wrappingLabel1;
	java.awt.Label label4;
	java.awt.Label label3;
	java.awt.Label label2;
	java.awt.Label label1;
	rawHist rawHist1;
	//}}

	void upDateLabels() {
	}



	class SymAction implements java.awt.event.ActionListener
	{
		public void actionPerformed(java.awt.event.ActionEvent event)
		{
			Object object = event.getSource();
			if (object == buttonDecH)
				buttonDecH_ActionPerformed(event);
			else if (object == buttonIncH)
				buttonIncH_ActionPerformed(event);
			else if (object == buttonDecA)
				buttonDecA_ActionPerformed(event);
			else if (object == buttonIncA)
				buttonIncA_ActionPerformed(event);
			else if (object == textFieldA0)
				textFieldA0_EnterHit(event);
			else if (object == textFieldH)
				textFieldH_EnterHit(event);
			else if (object == button1)
				button1_ActionPerformed(event);
			else if (object == button2)
				button2_ActionPerformed(event);


		}
	}



/**
 *  when a0 is changed this will update the bin width
 *	cross validation graph with the new a0's, but do not need to redefine new h
 *	if computehH == true then hHfact is redefined with the new h
 *	computehH set to true when h is changed
 */
void cvH(boolean computehH) {

		double minC=minCvalue;
		double maxC=maxCvalue;
		for (int i=0;i<30;i++) {
	    	if (computehH) {
	    		hHfact[i] = rawHist1.h * rawHist1.hfact[i];
	    	  }
	    	cvalue[i] = rawHist1.cv(rawHist1.X,hHfact[i],rawHist1.a0);
	    	minC = Math.min(minC,cvalue[i]);
	    	maxC = Math.max(maxC,cvalue[i]);
	    }
	    boolean redo = false;
	  if (minC < minCvalue)  {
	   		minCvalue = minC;
	   		redo = true;
	   	}

	   if (maxC > maxCvalue) {
	   		redo = true;
	   		maxCvalue = maxC;
	   	}
	   //	System.out.println("maxCvalue = " + maxCvalue + " maxc = " + maxC);
	  if (redo)  {
	   		//iScatter2.setData(hBfact,cvalueA,hBfact[0],hBfact[hBMax],minCvalue,maxCvalue);
	   		cvB(false); //reset a0 red dot, but will not change hbFact
	   	//	System.out.println("rescaling from H");
	   	}
	   		//cvB(false);
	   //	}

	    iScatter1.setData(hHfact,cvalue,hHfact[0],hHfact[hHMax],minCvalue,maxCvalue );
	    iScatter1.ndecy=4;

	}

	/**
	 * this recomputed cv graph for a0
	 * if h has changed, then computehB == true and hBfact is updated
	 * if computehB == false, hBfact will not be updated
	 */
	void cvB(boolean computehB) {
		double minC=minCvalue;
		double maxC=maxCvalue;
		 boolean redo = false;
		 double d = 1000000;
		 int index = 0;
		 if (computehB) {
		 	// redefines hBfact
			 	for (int i=0;i<20;i++) {
	    			hBfact[i] = rawHist1.h * rawHist1.bfact[i] + rawHist1.a0a ;
	    			if (Math.abs(hBfact[i] - rawHist1.a0) < d) {
	    				index = i;
	    				// index of hBfact closest to current a0
	    				d = Math.abs(hBfact[i] - rawHist1.a0);
	    			}

	    	}

	    	//System.out.println("index = " + index);
	    	d =  rawHist1.a0 - hBfact[index];

	    	// difference between current a0 and new a0

	    	//rawHist1.T =d; // probably could just use d

	    	for (int i=0;i<20;i++) {
	    		//shift hBfact so graph corresponds to new a0
	    		hBfact[i] =hBfact[i] +d;
	    	}
	    	inA = index;
	    	iScatter2.setCurrentPoint(inA);
	    	//System.out.println("a0 from hBfact =  " + hBfact[inA]);
	    	//System.out.println(rawHist1.h + " " + hBfact[0] + " " + hBfact[19]);

	    }
		for (int i=0;i<20;i++) {
	    	cvalueA[i] = rawHist1.cv(rawHist1.X,rawHist1.h,hBfact[i]);
	    	minC = Math.min(minC,cvalueA[i]);
	    	maxC = Math.max(maxC,cvalueA[i]);
	    }


	    	if (minC < minCvalue)  {
	   			minCvalue = minC;
	   			redo = true;
	   		}

	   		if (maxC > maxCvalue) {
	   			redo = true;
	   			maxCvalue = maxC;
	   		}

	   	if (redo) {
	    	//cvH(false); //this should rescale y axis for left cv; adjust for new minC & maxC in iScatter1
	    	iScatter1.setData(hHfact,cvalue,hHfact[0],hHfact[hHMax],minCvalue,maxCvalue );
	   		iScatter1.ndecy=4;
	    }


	    //iScatter2.setData(hBfact,cvalue);

	    iScatter2.setData(hBfact,cvalueA,hBfact[0],hBfact[hBMax],minCvalue,maxCvalue);

		iScatter2.ndecy=4;
		upDateButtonEnabled();

	}

	/**
	 * when user pressed on iscatter, reset the red dot, recalculate cv values, or
	 * reset hBfact accordingly
	 */
	public void pressed(Canvas cv,double x, double y) {


		if(cv.getBounds().x < 50) { //left scatterplot

			inH = getMin(x,hHfact);

			upDateH();


		}
		else {
			inA = getMin(x,hBfact);
			upDateA();
			upDateButtonEnabled();


		}
		upDateLabels(); // this is an empty function now

	}

	/**
	 * according to the current bin starting position and bin width, enable or disable
	 * + or - buttons to operate on bin width and bin starting position
	 */
	void upDateButtonEnabled() {
		if (inH>0)
			buttonDecH.setEnabled(true);
		else
			buttonDecH.setEnabled(false);
		if (inH<hHMax)
			buttonIncH.setEnabled(true);
		else
			buttonIncH.setEnabled(false);

		if (inA>0)
			buttonDecA.setEnabled(true);
		else
			buttonDecA.setEnabled(false);
		if (inA<hBMax)
			buttonIncA.setEnabled(true);
		else
			buttonIncA.setEnabled(false);
	}

	/**
	 * when select bin width changed, reset the red dot on iScatter1, reset H for
	 * rawHist1, recalculate cv for iScatter1 and redraw iScatter1. Recalculate cv for
	 * a0 and redefine hBfact on iScatter2
	 */
	void upDateH() {
			iScatter1.setCurrentPoint(inH);
			rawHist1.setH(hHfact[inH]);
			cvH(false);
			cvB(true); // redo cv for a0 and redefind hBfact
			//iScatter2.setCurrentPoint(inA);


			//upDateA(); // this will change both cv graphs

			textFieldH.setText(graphUtilities.format(rawHist1.h,4));
			showCV();
			upDateButtonEnabled();



			/*
			iScatter2.setCurrentPoint(inA);
			rawHist1.a0 = hBfact[inA];
			//rawHist1.reDraw();
			rawHist1.reFigure();
			rawHist1.setOffset2();
			*/
	}

	/**
	 * when select bin starting position changed, reset the red dot on iScatter2, reset a0 for
	 * rawHist1, recalculate cv for iScatter1 and redraw iScatter1 but do not change hHfact
	 */
	void upDateA() {
			//redefine a0 from inA
			//x=hBfact[in];
			iScatter2.setCurrentPoint(inA);
			rawHist1.a0 = hBfact[inA];

			rawHist1.reFigure(); //calculate bin counts and centers; change no parameters
			rawHist1.setOffset2();
			if (inA>0)
				buttonDecA.setEnabled(true);
			else
				buttonDecA.setEnabled(false);
			if (inA<hBMax)
				buttonIncA.setEnabled(true);
			else
				buttonIncA.setEnabled(false);

			cvH(false);	 // redo cv for h without changing hHfact
			textFieldA0.setText(graphUtilities.format(rawHist1.a0,4));
			showCV();
			upDateButtonEnabled();
			rawHist1.setOffset2();
	}

	/**
	 * return the minimum index of double[] fact, whose value is closest to x
	 */
	int getMin(double x, double [] fact) {
		int in = 0;
		double minDiff=Math.abs(x-fact[0]);

		for (int i=1;i<fact.length;i++) {

				if (Math.abs(x-fact[i]) < minDiff) {
					in =i;
					minDiff = Math.abs(x-fact[i]);
				}
		}
		return in;
	}


	/**
	 * When - button for bin width clicked, it changes inH value and calls upDateH()
	 */
	void buttonDecH_ActionPerformed(java.awt.event.ActionEvent event)
	{
		//if (inH>0) {
			inH--;
			upDateH();
			//buttonDecH.setEnabled(true);
		//}
		//else
			//buttonDecH.setEnabled(false);
	}

	/**
	 * When + button for bin width clicked, it changes inH value and calls upDateH()
	 */
	void buttonIncH_ActionPerformed(java.awt.event.ActionEvent event)
	{
		inH++;
		upDateH();
	}

	/**
	 * When - button for bin starting position clicked, it changes inA value and calls upDateA()
	 */
	void buttonDecA_ActionPerformed(java.awt.event.ActionEvent event)
	{
		inA--;
		upDateA();
	}

	/**
	 * When + button for bin starting position clicked, it changes inA value and calls upDateA()
	 */
	void buttonIncA_ActionPerformed(java.awt.event.ActionEvent event)
	{
		inA++;
		upDateA();
	}


	/**
	 * when OK button for bin width clicked, it calls textH()
	 */
	void button1_ActionPerformed(java.awt.event.ActionEvent event)
	{
		textH();
	}
	//{{DECLARE_MENUS
	//}}

	/**
	 * when user enters number for bin starting position, it calls textA()
	 */
	void textFieldA0_EnterHit(java.awt.event.ActionEvent event)
	{
		textA();
	}

	/**
	 * when user enters number for bin width, it calls textH()
	 */
	void textFieldH_EnterHit(java.awt.event.ActionEvent event)
	{
		textH();
	}

	void showCV() {
		rawHist1.setTitle("Cross validation: " + graphUtilities.format(rawHist1.cv(rawHist1.X,rawHist1.h,rawHist1.a0),4));
	}

	/**
	 * When user enters a number for bin width, it sets the rawHist to that H, change the red dot
	 * on iScatter1, recalculate cv in iScatter 1 and reset hHfact(adjusted for the current H), recalculate cv in iScatter2
	 * and reset hBfact for iScatter2
	 */
	void textH() {
		try {

			double h=  Double.valueOf(textFieldH.getText().trim()).doubleValue();
			if(h>0) {
				double diffH = Math.abs(h - hHfact[0]);
				int index=0;

				for (int i=0;i<30;i++) {
					if(Math.abs(h - hHfact[i]) <diffH) {
						index=i;
						diffH =  Math.abs(h - hHfact[i]);
					}
				}
				double r = 1/rawHist1.hfact[index];

				for (int i=0;i<30;i++) {
					double old = rawHist1.hfact[i];
					rawHist1.hfact[i]*=r;
					//System.out.println(i + " " + old + " " + rawHist1.hfact[i]);
				}

				rawHist1.setH(h);
				cvH(true);
				inH=index;
				cvB(true);
				iScatter1.setCurrentPoint(index);
				textFieldH.selectAll();
				showCV();
				upDateButtonEnabled();
				upDateA();
			}
			else {
				message m = new message("Bin width must be greater than 0.");
				m.show();
			}

		}
		catch (NumberFormatException e) {

		}
	}

	/**
	 * When user enters a number for bin width, it sets the rawHist to that a0,
	 * recalculate cv in iScatter2 and reset hBfact; recalculate cv in iScatter1 but
	 * not reset hHfact for iScatter1
	 */
	void textA() {
			try {
			boolean ok=true;
			double A0=  Double.valueOf(textFieldA0.getText().trim()).doubleValue();
			/*
			if (A0>rawHist1.X[0]) {
				message m = new message("Lower limit than smallest value.");
				m.show();
				ok=false;
			}

			if (A0 < rawHist1.a0a - rawHist1.h) {
				message m = new message("Lower limit too low.");
				m.show();
				ok=false;
			}
			*/
			if(ok) {
				rawHist1.a0=A0;
				cvB(true);
				rawHist1.reDraw();
				rawHist1.setOffset2();
				cvH(false);
				//iScatter2.setCurrentPoint(-1);
				textFieldA0.selectAll();
				showCV();
				upDateA();
			}

		}
		catch (NumberFormatException e) {

		}
	}

	/**
	 * when OK button for bin starting position clicked, it calls textA()
	 */
	void button2_ActionPerformed(java.awt.event.ActionEvent event)
	{
		textA();
	}

	class SymFocus extends java.awt.event.FocusAdapter
	{
		public void focusLost(java.awt.event.FocusEvent event)
		{
			Object object = event.getSource();
			if (object == textFieldH)
				textFieldH_FocusLost(event);
			else if (object == textFieldA0)
				textFieldA0_FocusLost(event);
		}

		public void focusGained(java.awt.event.FocusEvent event)
		{
			Object object = event.getSource();
			if (object == textFieldH)
				textFieldH_FocusGained(event);
			else if (object == textFieldA0)
				textFieldA0_FocusGained(event);
		}
	}

	/**
	 * The following FocusGain and FocusLost procedures are for textField selections
	 * go with tab key
	 */
	void textFieldH_FocusGained(java.awt.event.FocusEvent event)
	{
		textFieldH.selectAll();
	}

	void textFieldH_FocusLost(java.awt.event.FocusEvent event)
	{
		textFieldH.select(0,0);
	}

	void textFieldA0_FocusGained(java.awt.event.FocusEvent event)
	{
		textFieldA0.selectAll();
	}

	void textFieldA0_FocusLost(java.awt.event.FocusEvent event)
	{
		textFieldA0.select(0,0);
	}
}
