package hist;

import java.awt.*;
import RVLS.*;

public class rawHist extends hist {
	public double hmin,hmax,T; //hmin=(b-a)/512  hmax=(b-a)/2
	public double [] X;        //the data set for the histogram
	public int n,ne0=0,currWidth;
	boolean  whole;
	public int nic = 0; //# of bins on histogram, =(b-a0)/h
	public double a,b,a0,fb=0,a0a,h,ppV=0; //a=x[0]-1.1*h, b=x[n-1]+1.1h, a0=a
	public double [] hfact = new double[30]; //# log-scale perturbations of h
	public double [] bfact = new double[20]; //# shift increments
	double a0Pix = 0;

/*public void  decH() {   //decrease the frequency height of the Y intervals
	if( h > hmin/1.05 ) {
		h /= 1.05;
		reDraw();
	}

}
public double getA0() {
	return a0;
}
public void setA0(double a0) { //set start X position =a0+h/2 for the first bin
	this.a0=a0;
	reDraw();
}*/

public void setH(double h) { //set the frequency height for Y interval
	this.h=h;
	reDraw();
	//double ppV = getWidth()/h;
        double ppV = width/h;

	//reFigure();
}
/*public double getH() {
	return h;
}
/*public double [] getHfact() {
	return hfact;
}
public double [] getBfact() {
	return bfact;
}
/*
public void decFb () {
	if( fb >= 0.05 )  fb -= .05;
	reDraw();
}

public void incFb () {
	//if( fb < 0.5 )  fb += .05;
	if( fb < 1)  fb += .05;
	reDraw();
}

public void incH() {

	if( h < hmax*1.05 ) {
		h *= 1.05;
		reDraw();
	}

}

/**
 * Given a dataset, it will calculate h according to std, a0, b hmin, hmax, call redraw to
 * redraw the histogram according to new frequency and center data points.
 */
public void setData (double [] X) {
	this.X=X;
	nic=0;
	int [] ic = new int[512];
	//float [] centers = new float[512];
	//double [] cv= new double[32];



	for (int i=0;i<30;i++) {
		hfact[i] = Math.pow(2,(i-15)/15.0); //# log-scale perturbations of h

	}
	for (int i=0;i<20;i++) {
		double fi = (double) i;
		bfact[i] =  fi/20.0;		//# shift increments 5%
	}
	 n= X.length;
	double xbar=0;
	//whole = true;
	for (int i=0;i<n;i++) {
		xbar+=X[i];
		//if (Math.round(X[i]) != X[i]) whole = false;
	}
	//whole = false;
	xbar/=n;

	double std=0;
	for (int i=0;i<n;i++) {
		std+= Math.pow((X[i]-xbar),2);
	}
	std = Math.sqrt(std/(n-1));

		 h = 3.5 * std* Math.pow(n,-(1/3.0));
		//if (whole){
		// h = Math.round(h);

		//}
		//a = X[0]-1.1 *h;
		//b = X[n-1] + 1.1*h;
		a = X[0]-1.1 *h;
		b = X[n-1] + 1.1*h;
		//b = X[n-1] + h;
		hmin= (b-a)/512;
		hmax = (b-a)/2;
		//a0=a+fb*h;
		a0=a;
		a0a=a0;
		T = 0;



	reDraw();
}

	/**
	 *return the first observation with 0 frequency
	 */
	public int getLeadingEmpty(int[] f) {
		int i;
		for (i=0;i<f.length;i++) {
			if (f[i] != 0 ) break;
		}
		return i;
	}


	public void clearOffset() {
		int ff [] = getFreq();
		ne0 = getLeadingEmpty(ff);
		a0a=a0;
		offset2=0;
		repaint();
	}

	/**
	 *set up the offset2 for super class hist to control the bins
	 */
	public void setOffset2 () {

		int ff [] = getFreq();
		int ne = getLeadingEmpty(ff);

		double a0d= a0-a0a + (ne0-ne)*h;
		//offset2=(int) Math.rint(a0d*getWidth()/h);

		a0Pix = a0d * ppV;
		//offset2 = (int) Math.rint((ne0-ne)*getWidth()+a0Pix);
		offset2=  (int) Math.rint(a0Pix + (ne-ne0)*h*ppV);

	}

	/**
	 * bins already defined, recalculate the frequencies and center points to redraw the
	 * histogram.
	 */
	void reFigure(){
			double aa=a0;
			//System.out.println("nic = " + nic);
			int [] ic = new int[nic];
			float [] centers = new float[nic];
			for (int i=0;i<nic;i++) {
				ic[i]=0;
				centers[i] = (float) (aa + h/2 + i*h);
			//left edge + h/2 + number of bins over (i*h)
			//System.out.println(aa + i*h);
			}

			for (int i=0;i<n;i++) {
				int k = (int) Math.floor((X[i]-aa)/h);

				if ((k>=0) && (k<nic))
					ic[k]++;
			}
		setFreqAndMidPoints(ic,centers);
                this.width = width;
                setSlopes();
		//repaint();

	}
	/**
	 * redraw the histogram according to existing dataset X[], frequency interval height, and bin starting
	 * position parameter a0
	 */
	public void reDraw() {

		histData hd;
		hd = bin(X,h,a0);
		//hd = bin(X,h,a0+T);

		if ( ( Math.abs(Math.rint(a0+0.5*h) - (a0+0.5*h)) > 0.001 ) | (h<1.0))
		setXaxisDec(2);
		else setXaxisDec(0);

		setFreqAndMidPoints(hd.ic,hd.centers);
		int ff [] = getFreq();
		Rectangle r = getBounds();
		currWidth = (int) Math.rint(.95*((r.width -xoffset -rightMargin)/hd.ic.length));

                this.width = width;
                setSlopes();
		ne0 = getLeadingEmpty(ff);
		//ppV = getWidth()/h;
                ppV = width/h;	 //setWidth(currWidth);
		//repaint();

		//a0a=a0; // ******??
		setOffset2();
		//System.out.println("offset2= " + offset2);


}

/**
 * According to the existing dataset X, frequency height, and bin starting position parameter a0,
 * recalculate the center points and their frequencies for the dataset, to be used in reDraw procedure
 * to repaint the histogram
 */
	public histData bin(double [] X, double h, double a0) {
		float [] centers = new float[512];
		int [] ic = new int[512];
		int n = X.length;
		int ka,kb,maxic,k;
		ka = (int) Math.floor(a0/h);

		//if(nic == 0) {
			kb = (int) Math.floor((b-a0)/h);
			nic=kb;
			nic = Math.min(nic,512);
		//}


		//double aa=a0+T;

		double aa=a0;
		for (int i=0;i<nic;i++) {
			ic[i]=0;
			centers[i] = (float) (aa  + h/2 + i*h);
		}

		for (int i=0;i<n;i++) {
			k = (int) Math.floor((X[i]-aa)/h);

			if ((k>=0) && (k<nic))
				ic[k]++;
		}
		maxic=0;
		for (int i=0;i<nic;i++) {
			maxic = Math.max(maxic,ic[i]);

		}
		//System.out.println("-------\n");
		int [] ict;
		float [] centerst ;



		ict = new int[nic];
		centerst= new float[nic];
		for (int i=0;i<nic;i++) {
			//System.out.println(i + " " + centers[i] + " " + ic[i]);
			ict[i]=ic[i];
			centerst[i]=centers[i];
		}

		histData hh = new histData(ict,centerst,maxic,n);
		return hh;
	}

/**
 * Calculate the cross-validation according to the bin set up
 */
public double cv(double [] X, double h, double a0) {
	histData hdCv = bin(X,h,a0);
	int [] ic = hdCv.getIc();
	int n=hdCv.getN();
	double cvalue=0;
	for (int i=0; i< ic.length; i++)
		cvalue+= Math.pow(ic[i]/(float) n,2);
	cvalue=2/((n-1)*h) - cvalue*(n+1)/(n-1)/h;
	return cvalue;
}



}

/**
 * class constructor for histData, keep the frequencies, center points, maximum frequencies
 * and # of bins in this class
 */
class histData {
	int [] ic;
    float [] centers;
	int maxic,n;
	public histData(int [] ic, float [] centers, int maxic, int n) {
		this.ic=ic;
		this.centers=centers;
		this.maxic=maxic;
		this.n=n;
	}
	public int[] getIc() {
		return ic;
	}
	public int getN() {
		return n;
	}
}