package prop_conf;
/*
	A basic extension of the java.applet.Applet class
 */

import symantec.itools.awt.WrappingLabel;
import symantec.itools.awt.util.ProgressBar;
import java.awt.*;
import java.applet.*;
import RVLS.*;

public class propFrame extends closeableFrame implements Runnable
{
	double z;
	String ciStr;
	Thread th;
	int n=0,niter=0;
	double pi=0;
	boolean go=false;
	message m;
	public void start() {
		if(go) {
			th = new Thread(this);
			th.start();
		}
	}
	public void stop() {

		th=null;
	}
	public void run() {


		int v=0;

		int x=0;
		int c=0;
		double exp;
		double nd=n;
		double sum;
		exp=nd*pi;
		double y = (double)(niter);
		for (int i=0;i<niter;i++) {
			 sum=0;
			for (int j=0;j<n;j++) {
				double R = Math.random();
				if(R<pi) sum++;

			}
		if(i%20 == 0) {
			//int  pd = (int) Math.rint(((double)i/(double)( niter-1) * 100));
			//System.out.println(i+1 + " " + niter);
			double xxx= (double)(i+1);

			double r = xxx/y*100;
			int  pd = (int) Math.rint(r);
			//System.out.println(pd);

			//System.out.println(pd);
			try {
				progressBar1.setValue(pd);
			}
			catch (Exception e) {};
		}

			double p=sum/nd;
			double q=1-p;
			double sd = Math.sqrt(p*q/n);

			double range= z*sd+.5/nd;
			double LL = p-range;
			double UL = p+range;
			//double LL = p-1.96*sd-.5/nd;
			//double UL = p+1.96*sd+.5/nd;

			//double LL = p-1.96*sd;
			//double UL = p+1.96*sd;

			//System.out.println(LL + " " + p + " " + UL);
			if((LL<=pi) && (UL>=pi)) c++;
		}
		String nstr=n+"";
		nstr=jString(nstr,11);
		String niterStr= niter+"";
		niterStr=jString(niterStr,6);
		String piStr = graphUtilities.format(pi,2);
		piStr = jString(piStr,4);
		String pinc = niterStr  + nstr + "    " + piStr+ "   " +  ciStr + "      " +
		 graphUtilities.format((double) c *100/ (double) niter,1) + "%\n";
					//System.out.println(c + " " + niter);
					//System.out.println((double) c / (double) niter);
					progressBar1.setVisible(false);

		textArea1.append (pinc);
	}
	public String jString(String s, int L) {
		int SL = L - s.length();
		String st=s;
		for (int i=0;i<SL;i++) {
			st=" " + st;
		}
		return st;
	}
	public  propFrame()
	{
		// Take out this line if you don't use symantec.itools.net.RelativeURL or symantec.itools.awt.util.StatusScroller
		//symantec.itools.lang.Context.setApplet(this);

		// This code is automatically generated by Visual Cafe when you add
		// components to the visual environment. It instantiates and initializes
		// the components. To modify the code, only use code syntax that matches
		// what Visual Cafe can generate, or Visual Cafe may be unable to back
		// parse your Java file into its visual environment.
		//{{INIT_CONTROLS
		setLayout(null);
		setSize(623,388);
		setBackground(new Color(16777215));
		wrappingLabel1 = new symantec.itools.awt.WrappingLabel();
		try {
			wrappingLabel1.setText("This applet allows you to explore the validity of confidence intervals on a proportion with various values of N and Pi. After you specify N, Pi, the level of confidence, and the number of simulations you wish to perform, the applet samples data according to your specification and computes a confidence interval for each simulaton. The proportion of simulations for which the confidence interval contains Pi is recorded. If the method for constructing confidence intervals is valid, then about 95% of the 95% confidence intervals should contain Pi.");
		}
		catch(java.beans.PropertyVetoException e) { }
		wrappingLabel1.setBounds(51,260,540,98);
		add(wrappingLabel1);
		label6 = new java.awt.Label(" Number of                  Conf    Percent in");
		label6.setBounds(190,38,356,17);
		label6.setFont(new Font("Monospaced", Font.PLAIN, 12));
		add(label6);
		label5 = new java.awt.Label("Simulations     N      Pi   Level    Interval");
		label5.setBounds(190,54,356,17);
		label5.setFont(new Font("Monospaced", Font.PLAIN, 12));
		add(label5);
		label4 = new java.awt.Label("Confidence Level");
		label4.setBounds(48,123,121,20);
		add(label4);
		label3 = new java.awt.Label("Simulations",Label.RIGHT);
		label3.setBounds(20,85,80,23);
		add(label3);
		progressBar1 = new symantec.itools.awt.util.ProgressBar();
		progressBar1.setVisible(false);
		progressBar1.setBounds(234,190,238,44);
		add(progressBar1);
		textArea1 = new java.awt.TextArea("",0,0,TextArea.SCROLLBARS_VERTICAL_ONLY);
		textArea1.setEditable(false);
		textArea1.setBounds(188,73,370,105);
		textArea1.setFont(new Font("Monospaced", Font.PLAIN, 12));
		add(textArea1);
		label2 = new java.awt.Label("Pi",Label.RIGHT);
		label2.setBounds(42,62,58,20);
		add(label2);
		label1 = new java.awt.Label("N",Label.RIGHT);
		label1.setBounds(42,40,58,20);
		add(label1);
		textFieldN = new java.awt.TextField();
		textFieldN.setText("12");
		textFieldN.setBounds(107,40,58,20);
		textFieldN.setBackground(new Color(16777215));
		add(textFieldN);
		textFieldPi = new java.awt.TextField();
		textFieldPi.setText("0.5");
		textFieldPi.setBounds(107,63,58,20);
		textFieldPi.setBackground(new Color(16777215));
		add(textFieldPi);
		textField1 = new java.awt.TextField();
		textField1.setText("10000");
		textField1.setBounds(107,86,60,19);
		textField1.setBackground(new Color(16777215));
		add(textField1);
		Group1 = new CheckboxGroup();
		radioButton2 = new java.awt.Checkbox("90%",Group1, false);
		radioButton2.setBounds(48,148,73,20);
		add(radioButton2);
		radioButton1 = new java.awt.Checkbox("95%",Group1, false);
		radioButton1.setBounds(48,171,73,20);
		add(radioButton1);
		radioButton1.setState(true);
		radioButton3 = new java.awt.Checkbox("99%",Group1, false);
		radioButton3.setBounds(48,196,73,20);
		add(radioButton3);
		button1 = new java.awt.Button();
		button1.setLabel("Begin Simulation");
		button1.setBounds(277,201,125,21);
		button1.setBackground(new Color(16777215));
		add(button1);
		//}}
		setBackground(parameters.getBackGroundColor());
		setTitle("Confidence Interval on Proportions Simulation");

		//{{REGISTER_LISTENERS
		SymAction lSymAction = new SymAction();
		button1.addActionListener(lSymAction);
		//SymText lSymText = new SymText();
		SymFocus aSymFocus = new SymFocus();
		textFieldN.addFocusListener(aSymFocus);
		textFieldPi.addFocusListener(aSymFocus);
		textField1.addFocusListener(aSymFocus);
		//textArea1.addTextListener(lSymText);
		//}}

			//{{INIT_MENUS
		//}}
}
	public boolean getParams() {
		try {
			 n=  Integer.valueOf(textFieldN.getText().trim()).intValue();
			 if (n<1) {
			 	NumberFormatException ne = new NumberFormatException();
			 	throw ne;
			 }
		}
		catch (NumberFormatException e) {
			m= new message("N is not valid.");
			m.show();
			textFieldN.requestFocus();
			textFieldN.selectAll();
			return false;
		}

		try {
			 niter=  Integer.valueOf(textField1.getText().trim()).intValue();
			 if (niter<1) {
			 	NumberFormatException ne = new NumberFormatException();
			 	throw ne;
			 }
		}
		catch (NumberFormatException e) {
			m= new message("Number of simulations is not valid.");
			m.show();
			textField1.requestFocus();
			textField1.selectAll();
			return false;
		}

		try {
			  pi=  Double.valueOf(textFieldPi.getText().trim()).doubleValue();
			 if ((pi<=0) || (pi>=1)) {
			 	NumberFormatException ne = new NumberFormatException();
			 	throw ne;
			 }
		}
		catch (NumberFormatException e) {
			m= new message("pi is not valid.");
			m.show();
			textFieldPi.requestFocus();
			textFieldPi.selectAll();
			return false;
		}

		return true;
	}

	//{{DECLARE_CONTROLS
	symantec.itools.awt.WrappingLabel wrappingLabel1;
	java.awt.Label label6;
	java.awt.Label label5;
	java.awt.Label label4;
	java.awt.Label label3;
	symantec.itools.awt.util.ProgressBar progressBar1;
	CheckboxGroup Group1;
	java.awt.TextArea textArea1;
	java.awt.Label label2;
	java.awt.Label label1;
	java.awt.TextField textFieldN;
	java.awt.TextField textFieldPi;
	java.awt.TextField textField1;
	java.awt.Checkbox radioButton2;
	java.awt.Checkbox radioButton1;
	java.awt.Checkbox radioButton3;
	java.awt.Button button1;
	//}}

	class SymAction implements java.awt.event.ActionListener
	{
		public void actionPerformed(java.awt.event.ActionEvent event)
		{
			Object object = event.getSource();
			if (object == button1)
				button1_ActionPerformed(event);
		}
	}

	void button1_ActionPerformed(java.awt.event.ActionEvent event)
	{
		go = getParams();
		if(go) {

			ciStr = Group1.getSelectedCheckbox().getLabel();
			//System.out.println(ciStr);
			//double ci =Double.valueOf(Group1.getSelectedCheckbox().getLabel().trim()).doubleValue();
			 //ciStr = graphUtilities.format(ci,3);
			// ci =1-(1- ci)/2;
			// z = zdist.zinv(ci);
			if (ciStr.equals("95%")) z=1.96039;
			else if (ciStr.equals("99%")) z=2.5762;
			else z = 1.6421;

		//System.out.println( z);
			progressBar1.setVisible(true);
			go = true;
			start();
		}

	}



	//{{DECLARE_MENUS
	//}}

	/*class SymText implements java.awt.event.TextListener
	{
		public void textValueChanged(java.awt.event.TextEvent event)
		{
			Object object = event.getSource();
			if (object == textArea2)
				textArea2_TextValueChanged(event);
		}
	}

	void textArea2_TextValueChanged(java.awt.event.TextEvent event)
	{
		// to do: code goes here.
	}*/

	class SymFocus extends java.awt.event.FocusAdapter
	{
		public void focusLost(java.awt.event.FocusEvent event)
		{
			Object object = event.getSource();
			if (object == textFieldPi)
				textFieldPi_FocusLost(event);
			else if (object == textFieldN)
				textFieldN_FocusLost(event);
			else if (object == textField1)
				textField1_FocusLost(event);
		}

		public void focusGained(java.awt.event.FocusEvent event)
		{
			Object object = event.getSource();
			if (object == textFieldN)
				textFieldN_FocusGained(event);
			else if (object == textFieldPi)
				textFieldPi_FocusGained(event);
			else if (object == textField1)
				textField1_FocusGained(event);
		}
	}

	void textFieldN_FocusGained(java.awt.event.FocusEvent event)
	{
		textFieldN.selectAll();
	}

	void textFieldN_FocusLost(java.awt.event.FocusEvent event)
	{
		textFieldN.select(0,0);
	}

	void textFieldPi_FocusGained(java.awt.event.FocusEvent event)
	{
		textFieldPi.selectAll();
	}

	void textFieldPi_FocusLost(java.awt.event.FocusEvent event)
	{
		textFieldPi.select(0,0);
	}

	void textField1_FocusGained(java.awt.event.FocusEvent event)
	{
		textField1.selectAll();
	}

	void textField1_FocusLost(java.awt.event.FocusEvent event)
	{
		textField1.select(0,0);
	}

	/*class SymText implements java.awt.event.TextListener
	{
		public void textValueChanged(java.awt.event.TextEvent event)
		{
			Object object = event.getSource();
			if (object == textArea1)
				textArea1_TextValueChanged(event);
		}
	}

	void textArea1_TextValueChanged(java.awt.event.TextEvent event)
	{
		// to do: code goes here.
	}*/
}
