package rrange;

import RVLS.*;
import java.awt.*;
import java.applet.*;

public class rrscatter extends scatter {
	boolean inRect1,inRect2,first=true;
	int currxcoor,lastxcoor1,xadj1,lastxcoor2,xadj2,top,height,j;
	final int BARWIDTH=6;
	double [] xa = {1,2,3,4,3};
	double [] ya = {2,3,4,3,1};
	double LowerLim,UpperLim;


	RVLS.scatter scatter1;
	rangeFrame range=null;
	public rrscatter() {
		super();



		//{{REGISTER_LISTENERS
		SymMouse aSymMouse = new SymMouse();
		this.addMouseListener(aSymMouse);
		SymMouseMotion aSymMouseMotion = new SymMouseMotion();
		this.addMouseMotionListener(aSymMouseMotion);
		//}}
	}
	public void setScatter(RVLS.scatter _scatter1) {
		scatter1=_scatter1;
	}
	public void setApplet(rangeFrame range) {
		this.range= range; //casting to type Range
	}


	public void setData(double [] X, double [] Y, int N) {
		first=true;
		super.setData(X,Y,N);
	}

	public void drawPoints(Graphics g) {
		//g.setColor(Color.red);
		LowerLim=Lx.transformToValue(lastxcoor1+BARWIDTH);
		UpperLim=Lx.transformToValue(lastxcoor2);
		//System.out.println(range.Ptsin.getState());
		if (range.Ptsin.getState()) {
			for (int i = 0; i<N;i++) {
				if (XX[i]>LowerLim && XX[i]<UpperLim)
			    g.setColor(Color.blue);
			    else {
			    g.setColor(Color.darkGray);
				}
			g.fillOval(X[i]-2,Y[i]-2,4,4);
			}
		}
		else
		  	for (int i = 0; i<N;i++) {
				if (XX[i]<=LowerLim || XX[i]>=UpperLim)
				g.setColor(Color.blue);
			    else {
			    g.setColor(Color.darkGray);
				}
			g.fillOval(X[i]-2,Y[i]-2,4,4);
			}
	}


	//{{DECLARE_CONTROLS
	//}}



	public void paint(Graphics g){
		//g.drawLine(40,100,40,10);//Draw vertical line
		//g.drawLine(40,100,325,100);//Draw horizontal line


		if (first) {
			Point p1 = getUpperLeft();
			Point p2 = getLowerRight();
			lastxcoor1 = p1.x+1;
			lastxcoor2 = p2.x-5;
			top= p1.y+10;
			height = p2.y-top+1;
			first = false;
		}
		super.paint(g);
		//g.drawLine(p1.x,p1.y,p2.x,p2.y);
		//System.out.println("100 " + ds.Lx.transformToValue(100));
		//System.out.println("150 " + ds.Lx.transformToValue(150));
		//System.out.println(p2);

		g.fillRect(lastxcoor1,top,BARWIDTH,height);
		g.fillRect(lastxcoor2,top,BARWIDTH,height);

	}

	public void upDateGraphs() {
		double [] XR = new double[N];
		double [] YR= new double[N];
		LowerLim=Lx.transformToValue(lastxcoor1+BARWIDTH);
		UpperLim=Lx.transformToValue(lastxcoor2);
		j=0;


		if (range.Ptsin.getState()) {
			for (int i = 0; i<N;i++) {
				if (XX[i]>LowerLim && XX[i]<UpperLim) {
				XR[j] = XX[i];
				YR[j] = YY[i];
				j++;
				}

			}
		}
		else
		  	for (int i = 0; i<N;i++) {
				if (XX[i]<=LowerLim || XX[i]>=UpperLim) {
				XR[j] = XX[i];
				YR[j] = YY[i];
				j++;
				}

			}


		if (scatter1 != null) {
			//if (j>=1)
			//{
				scatter1.setData(XR,YR,j);
				/*scatter1.setVisible(true);
		    }
		    else
		    scatter1.setVisible(false);*/

			if (range!=null) {
				range.Nscat.setText(""+j);
			    range.rscat.setText(RVLS.graphUtilities.format(scatter1.getr(),2));

			    double sd2=scatter1.getSdx();
			    double tempvar1=scatter1.getr();
			    double tempvar2=(scatter1.getr()*(range.sd1/sd2));
			    double rc=tempvar2/Math.sqrt(1-tempvar1*tempvar1+tempvar2*tempvar2);
			   // range.rcscat.setText(RVLS.graphUtilities.format(rc,2));
			}
		}
			repaint();
	}


	class SymMouse extends java.awt.event.MouseAdapter
	{
		public void mouseReleased(java.awt.event.MouseEvent event)
		{
			Object object = event.getSource();
			if (object == rrscatter.this)
				rrscatter_MouseReleased(event);
		}

		public void mousePressed(java.awt.event.MouseEvent event)
		{
			Object object = event.getSource();
			if (object == rrscatter.this)
				rrscatter_MousePressed(event);
		}
	}

	void rrscatter_MousePressed(java.awt.event.MouseEvent event)
	{
		//System.out.println(event);

		if ((event.getX() >lastxcoor1 && event.getX() <lastxcoor1+BARWIDTH) && (event.getY() >20 && event.getY()<120)) {
			inRect1=true;
			xadj1=event.getX()-lastxcoor1;
			//System.out.println("point is within limit");
		}
		else {
			inRect1=false;
			//System.out.println("Point is outside limit");
		}
		if ((event.getX() >lastxcoor2 && event.getX() <lastxcoor2+BARWIDTH) && (event.getY() >20 && event.getY()<120)) {
			inRect2=true;
			xadj2=event.getX()-lastxcoor2;
			//System.out.println("point is within limit");
		}
		else {
			inRect2=false;
			//System.out.println("Point is outside limit");
		}

	}

	class SymMouseMotion extends java.awt.event.MouseMotionAdapter
	{
		public void mouseDragged(java.awt.event.MouseEvent event)
		{
			Object object = event.getSource();
			if (object == rrscatter.this)
				rrscatter_MouseDragged(event);
		}
	}

	void rrscatter_MouseDragged(java.awt.event.MouseEvent event)
	{
		if (inRect1) {
			//System.out.println("Mouse is dragging");
			Graphics g = getGraphics();
			//g.drawLine(40,100,40,10);//Draw vertical line
			g.setXORMode(this.getBackground());
			g.fillRect(lastxcoor1,top,BARWIDTH,height);

			Point p1 = getUpperLeft();

			currxcoor=event.getX()-xadj1;
			if (currxcoor<p1.x+1) {
				currxcoor=p1.x+1;

			}
			else if (currxcoor > (lastxcoor2-BARWIDTH)) {
			 	currxcoor=lastxcoor2-BARWIDTH;
			}
			  	g.fillRect(currxcoor,top,BARWIDTH,height);
			  	lastxcoor1=currxcoor;
		}
		if (inRect2) {
			//System.out.println("Mouse is dragging");
			Graphics g = getGraphics();
			g.setXORMode(this.getBackground());
			g.fillRect(lastxcoor2,top,BARWIDTH,height);
			currxcoor=event.getX()-xadj2;
			Point p2 = getLowerRight();
			if (currxcoor<(lastxcoor1+BARWIDTH)) {
				currxcoor=lastxcoor1+BARWIDTH;
			}
			else if (currxcoor > (p2.x-5)) {
			 	currxcoor=p2.x-5;
			}
			  	g.fillRect(currxcoor,top,BARWIDTH,height);
			  	lastxcoor2=currxcoor;
		}
	}

	void rrscatter_MouseReleased(java.awt.event.MouseEvent event)
	{
		upDateGraphs();
	}
}
