package reglines;

import java.awt.*;
import RVLS.*;
public class regLines extends scatter {
	    //drawScatter ds=null;
        Color [] lineColor = {Color.red,  Color.green,
		 Color.orange, Color.pink,Color.magenta, new Color(10485509),
			new Color(16731655), Color.cyan, new Color(13290751), Color.gray};
		Point starts[];
		Point ends[];
		Point anchor;
		Point currentpoint; //current line of line	//insert class definition here
		Point lastPoint;
		int currline;
	 	double [] sse;
	 	scatterPlotRegFrame sp;

		final int MAXLINES = 10;
		boolean dragging = false;

 public regLines() {

 	starts = new Point[MAXLINES]; // starting points
	 ends = new Point[MAXLINES]; //ending points
	 sse = new double[MAXLINES];
	 	//start of current line

	 	currline = 0; // number of lines


		//{{REGISTER_LISTENERS
		SymMouse aSymMouse = new SymMouse();
		this.addMouseListener(aSymMouse);
		SymMouseMotion aSymMouseMotion = new SymMouseMotion();
		this.addMouseMotionListener(aSymMouseMotion);
		//}}
	}
	public void getScatterPlot() {
		//System.out.println(getParent());
		sp=(scatterPlotRegFrame) getParent();
		// System.out.println("sp = " + sp);

	}
/* public boolean mouseDown(Event evt, int x, int y) {
		if (currline < MAXLINES) {
			anchor = new Point(x,y);
			dragging = true;
			lastPoint=anchor;

			return true;

		}
  	    else	   {
		//System.out.println("Too many lines.");
		return false;
	}
  }

 public boolean mouseUp(Event evt, int x, int y) {
	if (currline < MAXLINES) {
		addline(x,y);
		dragging = false;
		return true;
	}
	else return false;
  }

 public boolean mouseDrag(Event evt, int x, int y) {
 	if (currline < MAXLINES) {
 		currentpoint = new Point(x,y);
 		Graphics g = getGraphics();
 		g.setXORMode(this.getBackground());
		g.drawLine(anchor.x,anchor.y,lastPoint.x,lastPoint.y);
		g.drawLine(anchor.x,anchor.y,currentpoint.x,currentpoint.y);
 		lastPoint=currentpoint;
 		return true;
 	}
 	else return false;
  }
  */

void addline(int x, int y) {
	if(Math.abs(x - starts[currline].x) > 10) {
	double x0 = Lx.transformToValue(starts[currline].x);
	double xf = Lx.transformToValue(x);
	double y0 = Ly.transformToValue(starts[currline].y);
	double yf = Ly.transformToValue(y);
	double b = (yf-y0)/(xf-x0);
	double A = (yf + y0)/2 - b*(xf+x0)/2;
	//System.out.println(b + " " + A);
	int xp0 = (int) Lx.transform(minX);
	int xpf = (int) Lx.transform(maxX);
	int yp0 = (int) Ly.transform(b*minX+A);
	int ypf = (int) Ly.transform(b*maxX+A);
	starts[currline] = new Point(xp0,yp0);
	ends[currline] = new Point(xpf,ypf);
	sse[currline]=0;
	//sse[currline]=getSSE();
	for (int i=0;i<N;i++) {
		sse[currline]+=Math.pow(YY[i]-(b*XX[i]+A),2);
	}

	if(sse[currline] < 1000000) {
		sp.lineAdded(sse[currline]);
		currline++;
	}
	currentpoint = null;
	anchor = null;
}
	repaint();
  }
public void update(Graphics g)
{
		paint(g);
}
  public void paint (Graphics g) {

                Image offscreenImg = createImage(getSize().width,getSize().height);
                Graphics offscreenG = offscreenImg.getGraphics();;
                super.paint(offscreenG);
		offscreenG.clipRect(px0,py0,pxf-px0,pyf-py0);
		for (int i = 0; i < currline; i++) {
			offscreenG.setColor(lineColor[i]);
			offscreenG.drawLine(starts[i].x, starts[i].y,
			ends[i].x, ends[i].y);
		}
                if (dragging == true)
                {
                  offscreenG.setColor(lineColor[currline]);
                  offscreenG.drawLine(starts[currline].x, starts[currline].y, ends[currline].x, ends[currline].y);
                }
                g.drawImage(offscreenImg, 0, 0, this);
                //super.paint(offscreenImg);
                offscreenG.dispose();
	}
public void setCurrLine(int currline) {
		this.currline = currline;
	}




	class SymMouse extends java.awt.event.MouseAdapter
	{
		public void mouseReleased(java.awt.event.MouseEvent event)
		{
			Object object = event.getSource();
			if (object == regLines.this)
				regLines_MouseReleased(event);
		}

		public void mousePressed(java.awt.event.MouseEvent event)
		{
			Object object = event.getSource();
			if (object == regLines.this)
				regLines_MousePressed(event);
		}
	}

	void regLines_MousePressed(java.awt.event.MouseEvent event)
	{
		if (currline < MAXLINES) {
			/*anchor = new Point(event.getX(),event.getY());
			dragging = true;
			lastPoint=anchor;*/
                        starts[currline] = new Point(event.getX(),event.getY());


		}

	}

	class SymMouseMotion extends java.awt.event.MouseMotionAdapter
	{
		public void mouseDragged(java.awt.event.MouseEvent event)
		{
			Object object = event.getSource();
			if (object == regLines.this)
				regLines_MouseDragged(event);
		}
	}

	void regLines_MouseDragged(java.awt.event.MouseEvent event)
	{
		if (currline < MAXLINES) {
 		/*currentpoint = new Point(event.getX(),event.getY());
 		Graphics g = getGraphics();
 		g.setXORMode(this.getBackground());
		g.drawLine(anchor.x,anchor.y,lastPoint.x,lastPoint.y);
		g.drawLine(anchor.x,anchor.y,currentpoint.x,currentpoint.y);
 		lastPoint=currentpoint;*/
                dragging = true;
                ends[currline] = new Point(event.getX(),event.getY());
                repaint();
 	}
	}

	void regLines_MouseReleased(java.awt.event.MouseEvent event)
	{

		if (currline < MAXLINES) {
			addline(event.getX(),event.getY());
			dragging = false;
	}	}
}
