package reglines;

import RVLS.*;
import java.awt.*;
import java.applet.Applet;
import java.util.*;
public class scatterPlotRegFrame extends closeableFrame {
		scatterPlotRegFrame sp;
		int ci,si;
		final int N=250;
		final double SDX=10;
		final double SDY=10;
		final double MX=50;
		final double MY=50;
		Random rg = new Random();

		Color[] c = new Color[3];
		double [] sse = new double[10];
		Object [] mc = new Object[5];
	public scatterPlotRegFrame() {

		sp=this;
		LT Lx, Ly;
		ci=0;


		c[0] = Color.blue;
		c[1] = Color.red;
		c[2] = Color.green;


		si=0;

		//add(shapeChoice);

		//add (filledBox);

		boolean filled = false;
		double [] X,Y;
		int IY[],IX[];


		X = new double[N];
		Y = new double[N];
		/*
		double s1 = (Math.random() - .5);
		for (int i=0;i<N;i++) {
			X[i] = Math.random() *100;

			Y[i] =  s1 * X[i] + Math.random() *25;
			X[i] += MX;
			Y[i] += MY;
			//X[i] = 15*i;
			//Y[i] = X[i];
		}
		*/
		//X[5]=90;Y[5]=180;
		//int[] location = {50,300,10,160}	;// drawing area goes from 45-350 on X and 150-300 on Y
		int shape=scatter.CIRCLE;


		//{{INIT_CONTROLS
		setLayout(null);
		setVisible(false);
		setSize(626,352);
		setBackground(new Color(16777215));
		buttonMSE = new java.awt.Button();
		buttonMSE.setLabel("Show Minimum MSE");
		buttonMSE.setBounds(426,240,153,20);
		buttonMSE.setBackground(new Color(16777215));
		add(buttonMSE);
		buttonShowr = new java.awt.Button();
		buttonShowr.setLabel("Show r");
		buttonShowr.setBounds(506,160,60,20);
		buttonShowr.setBackground(new Color(16777215));
		add(buttonShowr);
		Group1 = new CheckboxGroup();
		radioButton5 = new java.awt.Checkbox("", Group1, false);
		radioButton5.setBounds(511,135,90,20);
		add(radioButton5);
		radioButton4 = new java.awt.Checkbox("", Group1, false);
		radioButton4.setBounds(511,114,90,20);
		add(radioButton4);
		radioButton3 = new java.awt.Checkbox("", Group1, false);
		radioButton3.setBounds(511,93,90,20);
		add(radioButton3);
		radioButton2 = new java.awt.Checkbox("", Group1, false);
		radioButton2.setBounds(511,72,90,20);
		add(radioButton2);
		radioButton1 = new java.awt.Checkbox("", Group1, false);
		radioButton1.setBounds(511,51,90,20);
		add(radioButton1);
		minMSE = new java.awt.Label("", Label.CENTER);
		minMSE.setBounds(430,265,153,25);
		minMSE.setFont(new Font("Serif", Font.PLAIN, 12));
		add(minMSE);
		stats = new java.awt.Label("");
		stats.setBounds(514,185,81,21);
		stats.setFont(new Font("Serif", Font.PLAIN, 12));
		add(stats);
		checkbox1 = new java.awt.Checkbox("Draw regression line");
		checkbox1.setBounds(72,274,174,28);
		add(checkbox1);
		xCanvas1 = new xCanvas();
		xCanvas1.setBounds(437,50,52,175);
		xCanvas1.setFont(new Font("Helvetica", Font.BOLD, 12));
		add(xCanvas1);
		button1 = new java.awt.Button();
		button1.setLabel("New Data");
		button1.setBounds(314,274,86,28);
		//button1.setBackground(new Color(16777215));
		add(button1);
		plot1 = new regLines();
		plot1.setBounds(11,35,403,235);
		add(plot1);
		label1 = new java.awt.Label("MSE",Label.CENTER);
		label1.setBounds(432,31,64,18);
		add(label1);
		//}}
		setBackground(parameters.getBackGroundColor());
		setTitle("Regression by Eye Simulation");
		mc[0] = radioButton1;
		mc[1] = radioButton2;
		mc[2] = radioButton3;
		mc [3] = radioButton4;
		mc [4]=radioButton5;
		plot1.setData(X,Y);
		setStatFields();
		plot1.shape=scatter.CIRCLE;
		plot1.filled=true;
		minMSE.setVisible(true);
		plot1.getScatterPlot();
		newDataSet();

		//{{REGISTER_LISTENERS
		SymItem lSymItem = new SymItem();
		checkbox1.addItemListener(lSymItem);
		SymAction lSymAction = new SymAction();
		button1.addActionListener(lSymAction);
		//SymMouse aSymMouse = new SymMouse();
		//this.addMouseListener(aSymMouse);
		buttonShowr.addActionListener(lSymAction);
		buttonMSE.addActionListener(lSymAction);
		//}}

			//{{INIT_MENUS
		//}}
}
public void lineAdded(double e) {
	double MSE=e/N;
	xCanvas1.lineAdded(MSE);

}



	//{{DECLARE_CONTROLS
	java.awt.Button buttonMSE;
	java.awt.Button buttonShowr;
	java.awt.Checkbox radioButton5;
	CheckboxGroup Group1;
	java.awt.Checkbox radioButton4;
	java.awt.Checkbox radioButton3;
	java.awt.Checkbox radioButton2;
	java.awt.Checkbox radioButton1;
	java.awt.Label minMSE;
	java.awt.Label stats;
	java.awt.Checkbox checkbox1;
	xCanvas xCanvas1;
	java.awt.Button button1;
	regLines plot1;
	java.awt.Label label1;
	//}}


	void checkbox1_Action(java.awt.event.ItemEvent event) {
		boolean state = checkbox1.getState();
		plot1.setRegLine(state);
                if (state)
                xCanvas1.setRegLine(plot1.getSSE()/(double)N);
                else
		xCanvas1.setRegLine(false);

	}






	class SymItem implements java.awt.event.ItemListener
	{
		public void itemStateChanged(java.awt.event.ItemEvent event)
		{
			Object object = event.getSource();
			if (object == checkbox1)
				checkbox1_Action(event);


		}
	}




	class SymAction implements java.awt.event.ActionListener
	{
		public void actionPerformed(java.awt.event.ActionEvent event)
		{
			Object object = event.getSource();
			if (object == button1)
				button1_ActionPerformed(event);
			else if (object == buttonShowr)
				buttonShowr_ActionPerformed(event);
			else if (object == buttonMSE)
				buttonMSE_ActionPerformed(event);
		}
	}

	void button1_ActionPerformed(java.awt.event.ActionEvent event)
	{
		newDataSet();

	}
	void newDataSet() {
		plot1.setRegLine(false);
		checkbox1.setState(false);

		double [] X,Y;
		//System.out.println("button1");
		X = new double[N];
		Y = new double[N];

		double r=.75*rg.nextDouble();
		double s=-1;
		if (rg.nextFloat() <.5) s=1;
		double exp = SDX*SDX;
		double unexp = exp/(r*r) - exp;
		double sdErr = Math.sqrt(unexp);
		double sdu = Math.sqrt(exp + unexp);
		double sdAdj = SDY/sdu;
		for (int i=0;i<N;i++) {
			//X[i] = Math.random()*100;
			//Y[i] =  s1 * X[i] + Math.random() *100;
			X[i] = rg.nextGaussian()*SDX;
			Y[i] = sdAdj*(s*X[i] + sdErr*rg.nextGaussian());
			X[i] += MX;
			Y[i] += MY;

		}
		//Group1.getCurrent().setState(false);
		Group1.setSelectedCheckbox(null);
		//stats.setVisible(false);
		stats.setText(" ");
		//minMSE.setVisible(false);
		minMSE.setText(" ");
		checkbox1.setState(false);


		plot1.setData(X,Y);
		setStatFields();
		plot1.setCurrLine(0);
		xCanvas1.setCurrLine(0);



	}


	void setStatFields() {
		double r = plot1.getr();
		double sse = plot1.getSSE()/N;
		//stats.setText("r = " + RVLS.graphUtilities.format(r,2));
		//minMSE.setText( "Minimum MSE = " + RVLS.graphUtilities.format(sse,0));
		int ca = (int)Math.floor(rg.nextFloat()*5);
		//Checkbox cbx = (Checkbox) mc[ca];
		//cbx.setLabel("Hello");
		for (int i=0;i<5;i++) {
			double d = (double) (ca-i);
			d/=10;
			((Checkbox) mc[i]).setLabel(RVLS.graphUtilities.format(r-d,2));
		}


		//((Checkbox) mc[ca]).setLabel(graphUtilities.format(r,2));

	}


	void buttonShowr_ActionPerformed(java.awt.event.ActionEvent event)
	{
		stats.setText("r = " + RVLS.graphUtilities.format(plot1.getr(),2));
	}

	void buttonMSE_ActionPerformed(java.awt.event.ActionEvent event)
	{
		double Mse = plot1.getSSE()/N;
		minMSE.setText( "Minimum MSE = " + RVLS.graphUtilities.format(Mse,0));

	}
	//{{DECLARE_MENUS
	//}}
}
